import React, { useState, useEffect } from "react";
import { Breadcrumb, Layout, Menu, Avatar, Badge, Space, Dropdown, Row, Col } from "antd";
import { Route, Link, Redirect } from "react-router-dom";
import { System_msgList } from "../services/message";
import { setToken, getUserPath } from "../utils/auth";
import {
  DownOutlined,
  SettingOutlined,
  LoginOutlined,
  MenuUnfoldOutlined,
  MenuFoldOutlined,
  UserOutlined,
  MessageOutlined,
  BellOutlined
} from "@ant-design/icons";
import "./index.scss";
import { BreadcrumbNameMap } from "../router/config";
import "@ant-design/pro-table/dist/table.css";
import logo from "../assets/img/logo.png";
import MiniLogo from "../assets/img/miniLog.png";
import { connect } from "react-redux";
import openIM from "../utils/openIM"
import { GetOpenIM } from "../services/user";
import { setIMlist } from "../redux/action/userinfo";
import {
  CbEvents
} from 'open-im-sdk'


const { Header, Content, Sider } = Layout;



const AdminLayout: any = (props: any) => {
  const [currentKeys, setCurrentKeys]: any = useState(["/admin/role"]);
  const [collapsed, setState] = React.useState(false);
  const [company, setCompany]: any = useState(false);
  const [unread, setunread]: any = useState("0")
  const [userpath, setuserpath]: any = useState([]);
  const [total, setTotal] = useState(0);
  const reallyRoutes = userpath
    .map((item) => (item.children ? [item, ...item.children] : item))
    .flat();
  const handleToggle = () => {
    setState(!collapsed);
  };
  useEffect(() => {
    if (window.opener) {
      setToken().then(res => {
        setuserpath(getUserPath)
      })
    } else {
      setuserpath(getUserPath)
    }
  }, [])
  useEffect(() => {
    if (window.opener) {
      const token = sessionStorage.getItem('area-token')
      if (token) {
        getTotal();
      } else {
        setToken().then(res => {
          getTotal();
        })
      }
    } else {
      getTotal();
      const reallyRoutes = getUserPath()
        .map((item) => (item.children ? [item, ...item.children] : item))
        .flat();
      let flag
      reallyRoutes.map(item => {
        if (item.path == props.history.location.pathname) {
          flag = true
        }
      })
      if (!flag) {
        window.location.href = reallyRoutes[0].path
      }
    }
  }, [props.history.location.pathname]);
  useEffect(() => {
    openIM.getLoginStatus().then(res => {
    }).catch(err => {
      loginIM();
    })
  }, [])
  useEffect(() => {
    const company = sessionStorage.getItem("company");
    setCompany(company);
  }, [])
  useEffect(() => {
    const route = props.history.location.pathname.split("/")
    if (route.length < 5) {
      setCurrentKeys([props.history.location.pathname]);
    }
  }, [props.history.location.pathname]);
  const getTotal = async () => {
    const data: any = await System_msgList({});
    const { total } = data;
    setTotal(total)
  }
  const loginIM = async () => {
    const openim_id = sessionStorage.getItem('openim_id')
    const { data } = await GetOpenIM({ openim_id });
    const config: any = {
      userID: openim_id,                                // 用户ID
      token: data.token,                                    // 用户token
      url: "wss://www.wxmini.getensh.com:60001",    // jssdk server ws地址
      platformID: 5,                                    // 平台号
    };
    openIM.login(config).then((async) => {
      const options = {
        offset: 0,
        count: 10
      }
      openIM.getConversationListSplit(options).then(({ data }) => {
        const str = JSON.parse(data);
        const val = str.map(item => {
          return { ...item, latestMsg: JSON.parse(item.latestMsg) }
        })
        props.setIMList(val);
      })
      openIM.getTotalUnreadMsgCount().then(res => {
        setunread(res.data)
      });
      openIM.on(CbEvents.ONTOTALUNREADMESSAGECOUNTCHANGED, (res) => {
        setunread(res.data)
      });
      openIM.on(CbEvents.ONCONVERSATIONCHANGED, (res) => {
        const str = JSON.parse(res.data);
        let item = str[0];
        setitem({ ...item });
      })
      openIM.on(CbEvents.ONNEWCONVERSATION, (res) => {
        const str = JSON.parse(res.data);
        let item = str[0];
        setitem({ ...item });
      })
    })
  };
  const [item, setitem]: any = useState();
  const [chatList, setchatList]: any = useState([]);
  useEffect(() => {
    setchatList([...props.imList]);
  }, [props.imList])
  useEffect(() => {
    if (item) {
      let data = chatList;
      let index = data.findIndex((val) => val.conversationID === item.conversationID);
      if (index > -1) {
        if (item.unreadCount > 0) {
          data.splice(index, 1);
          data.unshift({ ...item, latestMsg: JSON.parse(item.latestMsg) });
        } else {
          data.splice(index, 1, { ...item, latestMsg: JSON.parse(item.latestMsg) })
        }
      } else {
        data.unshift({ ...item, latestMsg: JSON.parse(item.latestMsg) });
      }
      props.setIMList(data);
    }
  }, [item]);
  const handleLogOut = () => {
    window.sessionStorage.clear();
    window.opener = null
    window.location.href = "/login";
    openIM.logout().then(res => {
      console.log("logout suc...");
    })
  };
  const switchRoute = (route) => {
    props.history.push(route.path);
    setCurrentKeys([route.path]);
  };
  const paths = props.history.location.pathname.split("/").filter((i) => i);
  const arr: any = []
  paths.map((_, index) => {
    const url = "/" + paths.slice(0, index + 1).join("/");
    arr.push(url)
  });
  const newArr = arr.slice(1, 2)
  const residueArr = arr.slice(2)
  const breadcrumbItems = residueArr.map(item => {
    return (
      <Breadcrumb.Item href={item} key={item}>
        {BreadcrumbNameMap[item]}
      </Breadcrumb.Item>
    );
  })

  return (
    <Layout style={{ minHeight: "100vh" }} >
      <Sider
        className={"sider-roll"}
        trigger={null}
        collapsible
        collapsed={collapsed}
        style={{
          height: "100vh",
          position: "fixed",
          left: 0,
          background: "#222328"
        }}
      >
        <div className="header-logo">
          <Link to="/home">
            {collapsed ? (
              <img className="logo" src={MiniLogo} alt="" />
            ) : (
              <img className="logo" src={logo} alt="" />
            )}
          </Link>
        </div>
        <Menu mode="inline" selectedKeys={currentKeys} theme="dark" >
          {userpath
            .filter((item) => !item.hideInMenu)
            .map((route) => {
              return route.children &&
                route.children.filter(({ hideInMenu }) => !hideInMenu)
                  ?.length ? (
                <Menu.SubMenu
                  key={route.path}
                  title={route.title}
                  icon={route.icon}
                >
                  {route.children
                    .filter((item) => !item.hideInMenu)
                    .map((child) => (
                      <Menu.Item
                        key={child.path}
                        onClick={() => switchRoute(child)}
                      >
                        {child.title}
                      </Menu.Item>
                    ))}
                </Menu.SubMenu>
              ) : (
                <Menu.Item
                  key={route.path}
                  onClick={() => switchRoute(route)}
                  icon={route.icon}
                >
                  {route.title}
                </Menu.Item>
              );
            })}
        </Menu>
      </Sider>
      <Layout style={{ paddingLeft: collapsed ? 80 : 200 }}>
        <Header className="site-layout-background" style={{ padding: 0 }}>
          {React.createElement(
            collapsed ? MenuUnfoldOutlined : MenuFoldOutlined,
            {
              className: "trigger",
              onClick: handleToggle
            }
          )}
          <Row style={{ width: "100%" }} align="middle">
            <Col span={6} push={18} style={{ display: "flex", justifyContent: "center" }}>
              <Space size="middle">
                <Link to="/admin/customer-service">
                  <Badge count={unread} overflowCount={10}>
                    <Avatar icon={<MessageOutlined />} />
                  </Badge>
                </Link>
                <Link to="/admin/message">
                  <Badge count={total} overflowCount={10}>
                    <Avatar icon={<BellOutlined />} />
                  </Badge>
                </Link>
                <Dropdown
                  overlay={() => {
                    return (
                      <Menu>
                        <Menu.Item key={'setting'} disabled={company ? false : true}>
                          <Link to="/admin/person">
                            <SettingOutlined /> 个人设置
                          </Link>
                        </Menu.Item>
                        <Menu.Item key={'password'} disabled={company ? false : true}>
                          <Link to="/admin/setting/password">
                            <SettingOutlined /> 修改密码
                          </Link>
                        </Menu.Item>
                        <Menu.Item key={'loginOut'}>
                          <a
                            target="_blank"
                            rel="noopener noreferrer"
                            onClick={handleLogOut}
                          >
                            <LoginOutlined></LoginOutlined>退出
                          </a>
                        </Menu.Item>
                      </Menu>
                    );
                  }}
                >
                  <a
                    className="ant-dropdown-link"
                    onClick={(e) => e.preventDefault()}
                  >
                    <Avatar
                      style={{ backgroundColor: "#87d068" }}
                      icon={<UserOutlined />}
                    />
                    <span
                      className="layout-header-username"
                      style={{ marginLeft: 3 }}
                    >
                      {sessionStorage.getItem("username") || "admin"}
                    </span>
                    <DownOutlined></DownOutlined>
                  </a>
                </Dropdown>
              </Space>
            </Col>
            <Col span={18} pull={6}>
              <Breadcrumb className="header-breadcrumb">
                <Breadcrumb.Item>
                  {BreadcrumbNameMap[newArr[0]]}
                </Breadcrumb.Item>
                {breadcrumbItems}
              </Breadcrumb>
            </Col>
          </Row>
        </Header>
        <Content className="layout-content">
          {reallyRoutes.map((route: any) => (
            <Route
              exact={route.exact}
              path={route.path}
              key={route.path}
              component={route.component} />
          ))}
        </Content>
      </Layout>
    </Layout>
  );
};
const mapStateToProps = (state) => {
  return {
    imList: state.getIMList.list
  }
}
const mapDispatchToProps = (dispatch) => {
  return {
    setIMList: (userInput) => dispatch(setIMlist(userInput)),
  }
}
export default connect(mapStateToProps, mapDispatchToProps)(AdminLayout);
