import HomePage from "../views/Home";
import Login from "../views/User/Login/Login";
import React, { lazy, Suspense } from "react";
import { createFromIconfontCN } from "@ant-design/icons";

//
//住户管理系统消息
const SystemMessage = lazy(() => import("../views/Message/message"))
const OwnerList = lazy(() => import("../views/Owner/index"));
//个人设置
const Person = lazy(() => import("../views/User/person"))
//住户信息--房屋
const HouseInfo = lazy(() => import("../views/Owner/houseInfo"))
//住户信息--车辆
const CarInfo = lazy(() => import("../views/Owner/carInfo"))
const OwnerExamine = lazy(() => import("../views/Owner/examine"));
const CompanyInfo = lazy(() => import("../views/Settings/info"));
const Neighbor = lazy(() => import("../views/Service/neighbor/index"));
const PageList = lazy(() => import("../views/Service/neighbor/page-list"));
//小区服务-邻里社区-文章详情
const ArticleDetail = lazy(() => import("../views/Service/neighbor/articleDetail"))
const Comments = lazy(() => import("../views/Service/neighbor/comments"));
//小区服务/公告通知/发布公告
const AddNotice = lazy(() => import("../views/Service/announcement/addNotice"))
//小区服务/公告通知/编辑公告
const EditNotice = lazy(() => import("../views/Service/announcement/editNotice"))
//小区服务/公告通知/公告详情
const DetailNotice = lazy(() => import("../views/Service/announcement/detailNotice"))
const Notice = lazy(() => import("../views//Service/announcement/notice"));
const Activity = lazy(() => import("../views/Service/event/activity"));
//小区服务/社区活动/添加活动
const AddEvent = lazy(() => import("../views/Service/event/addEvent"))
//小区服务/社区活动/修改活动
const EditEvent = lazy(() => import("../views/Service/event/editEvent"))
//小区服务/社区活动/活动详情
const DetailEvent = lazy(() => import("../views/Service/event/detailEvent"))
//小区服务/社区活动/报名列表
const EventSign = lazy(() => import("../views/Service/event/eventSign"))
//小区服务/投票活动
const VoteList = lazy(() => import("../views/Service/vote/index"))
//小区服务/投票活动/添加投票
const AddVote = lazy(() => import("../views/Service/vote/addVote"))
//小区服务/投票活动/添加投票/投票详情
const DetailVote = lazy(() => import("../views/Service/vote/detailVote"))
//小区服务/投票活动/添加投票/修改投票
const EditVote = lazy(() => import("../views/Service/vote/editVote"))
//小区服务/投票活动/投票结果
const VoteResult = lazy(() => import("../views/Service/vote/voteResult"))
//小区服务/投票活动/投票结果/详情
const ResultDetail = lazy(() => import("../views/Service/vote/resultDetail"))
//小区服务/服务电话
const Phone = lazy(() => import("../views/Service/phone"))
//小区服务/服务电话/分类管理
const PhoneClass = lazy(() => import("../views/Service/phone/class"))
const ChargeSetup = lazy(() => import("../views/Charge/setup"));
// 绑定房屋
const ChargeSetupBindRoom = lazy(
  () => import("../views/Charge/setup-bind-room")
);
// 绑定汽车
const ChargeSetupBindCar = lazy(() => import("../views/Charge/setup-bind-car"));
// 绑定车位
const ChargeSetupBindParking = lazy(
  () => import("../views/Charge/setup-bind-parking")
);
// 房屋收费
const HouseCharge = lazy(() => import("../views/Charge/house"));
// 抄表管理
const Meter = lazy(() => import("../views/Charge/meter"));

// 停车设置
// 车辆管理
const ParkingCar = lazy(() => import("../views/Parking/Car"));
// 停车场管理
const ParkingList = lazy(() => import("../views/Parking/manager"));
// 停车位管理
const ParkingPosition = lazy(() => import("../views/Parking/position"));

// 楼盘管理
// 房屋管理
const BuildingHouse = lazy(() => import("../views/building/house"));
// 楼栋管理
const Buildings = lazy(() => import("../views/building/list"));
// 单元管理
const BuildingUnit = lazy(() => import("../views/building/unit"));
// 业主信息
const HouseholdUserlist = lazy(() => import("../views/building/userlist"))
//楼盘管理--楼栋管理
const Manager = lazy(() => import("../views/building/manager"))

// 创建房屋租赁
const HouseLeaseCreate = lazy(() => import("../views/House/lease-create"));
const HouseLeaseManager = lazy(() => import("../views/House/lease-manager"));
// 租赁管理-房屋明细
const HouseDetails = lazy(() => import("../views/House/lease-details"))
//租赁管理-审核
const HouseCheck = lazy(() => import("../views/House/lease-check"))
//租赁管理--经济人管理
const Broker = lazy(() => import("../views/House/assigning-broker"))
//租赁管理--预约看房
const AppointmentHouse = lazy(() => import("../views/House/appointment"))
// 房屋收费-明细
const HouseArrears = lazy(() => import("../views/Charge/house-arrears"));
// 房屋收费-账单明细
const HouseBill = lazy(() => import("../views/Charge/house-bill"));
// 房屋收费-账单明细-缴费
const HouseBillHandle = lazy(() => import("../views/Charge/bill-handle"));
// 房屋收费-账单明细-预存
const HouseBillPrestore = lazy(() => import("../views/Charge/bill-prestore"));
// 房屋收费-账单明细-预存--打印小票
const PrintReceipt = lazy(() => import("../views/Charge/print/receipt"));
// 房屋收费-账单明细-预存--打印收据
const Quittance = lazy(() => import("../views/Charge/print/receiptQuittance"));

// 车辆收费
const CarCharge = lazy(() => import("../views/Charge/car"));
// 车辆收费-查看费用
const CarChargeBill = lazy(() => import("../views/Charge/car-bill"));
// 车位收费
const ChargeParkingPosition = lazy(
  () => import("../views/Charge/parking-position")
);
// 车位收费-查看费用
const ChargeParkingPositionBill = lazy(
  () => import("../views/Charge/parking-position-bill")
);

// 预缴设置
const Arrears = lazy(() => import("../views/Charge/arrears"));
// 收费设置
const ChargeSetting = lazy(() => import("../views/Charge/setting"));
// 应付账单
const ShouldBill = lazy(() => import("../views/Charge/should-bill"));
// 已缴账单
const PayBill = lazy(() => import("../views/Charge/payed-bill"));
// 废弃账单
const ScrapBill = lazy(() => import("../views/Charge/scrap-bill"));
// 缴费订单
const PaymentBill = lazy(() => import("../views/Charge/payment-bill"));
//缴费订单--详情
const PaymentBillDetail = lazy(() => import("../views/Charge/payment-bill-detail"))

//用户管理
// 权限组
const UserRoles = lazy(() => import("../views/User/roles"));
//权限 
const RoleList = lazy(() => import("../views/User/roleList"))
//添加权限
const AddRole = lazy(() => import("../views/User/addRole"))
//修改权限
const EditRole = lazy(() => import("../views/User/editRole"))
//成员
const RoleUser = lazy(() => import("../views/User/roleUser"))
// 用户
const UserList = lazy(() => import("../views/User/account"));
//添加用户
const AddUser = lazy(() => import("../views/User/addUser"))
//修改用户
const EditUser = lazy(() => import("../views/User/editUser"))
//部门
const Department = lazy(() => import("../views/User/department"))

// 报事报修相关
const FixType = lazy(() => import("../views/Fix/type"));
const FixOnlineForm = lazy(() => import("../views/Fix/online-form"));
const FixReturnVisit = lazy(() => import("../views/Fix/return-visit"));
const FixTodo = lazy(() => import("../views/Fix/to-do"));
const FixOrderDetail = lazy(() => import("../views/Fix/order-detail"));

// 投诉相关
const Complaint = lazy(() => import("../views/Complaint/index"));
const ComplaintHandle = lazy(() => import("../views/Complaint/handle"));
const ComplaintReturnVisit = lazy(
  () => import("../views/Complaint/return-visit")
);
const ComplaintDetail = lazy(() => import("../views/Complaint/order-detail"));
//设备管理 -门禁
const DoorControl = lazy(() => import("../views/Device/door"))
//开门权限
const DoorPermission = lazy(() => import("../views/Device/doorPermission"))
//门禁管理
const FaceManager = lazy(() => import("../views/Device/faceManager"))
//IC卡管理
const ICManager = lazy(() => import("../views/Device/ICmanager"))
const Command = lazy(() => import("../views/Device/Command"))
//门禁--开门记录
const DoorRecord = lazy(() => import("../views/Device/doorRecord"))
//门禁--访客留影
const VisitroRecord = lazy(() => import("../views/Device/visitorRecord"))
//系统设置 --修改密码
const EditPassword = lazy(() => import("../views/Settings/editPassword"))

//功能应用--应用
const Application = lazy(() => import("../views/Application/application"))
//功能应用--预览
const Preview = lazy(() => import("../views/Application/preview"))
//功能应用--购买
const BuyApplication = lazy(() => import("../views/Application/buyapplication"))
//功能应用--应用订单
const OrderList = lazy(() => import("../views/Application/order"))
//功能应用--已购订单
const OwnerApplication = lazy(() => import("../views/Application/ownerapplication"))

//短信套餐--所有短信套餐列表
const Msg_package = lazy(() => import("../views/Msg/msg_package"))
//短信套餐--购买
const BuyMsg = lazy(() => import("../views/Msg/buyMsg"))
//短信套餐--短信订单
const OrderMsg = lazy(() => import("../views/Msg/order"))
//短信套餐--已购短信套餐
const OwnerMsg = lazy(() => import("../views/Msg/ownerMsg"))
//短信套餐--详情
const Msg_Detail = lazy(() => import("../views/Msg/detail"))
//IM
const CustomerService = lazy(()=>import("../views/Customer/customer-service"))


export const Wrapper = (Component: any) => (props: any) => {
  return (
    <Suspense fallback={''}>
      <Component />
    </Suspense>
  );
};

export const BreadcrumbNameMap: any = {
  "/admin/index": "系统首页",
  "/admin/message": "系统消息",
  "/admin/person": "个人信息",
  "/admin/owner": "住户管理",
  "/admin/owner/info": "住户信息",
  "/admin/owner/info/houseinfo": "房屋",
  "/admin/owner/info/carinfo": "车辆",
  "/admin/owner/examine": "住户审核",
  "/admin/building": "楼盘管理",
  "/admin/building/list": "楼栋管理",
  "/admin/building/unit": "单元管理",
  "/admin/building/house": "房屋管理",
  "/admin/building/house/userlist": "住户",
  "/admin/building/house/manager": "楼栋管家",
  "/admin/service": "小区服务",
  "/admin/service/neighbor": "社区邻里",
  "/admin/service/neighbor/page-list": "文章列表",
  "/admin/service/neighbor/page-list/detail": "详情",
  "/admin/service/neighbor/comments": "评论列表",
  "/admin/service/notice": "公告通知",
  "/admin/service/notice/addnotice": "发布",
  "/admin/service/notice/editnotice": "修改",
  "/admin/service/notice/detailnotice": "详情",
  "/admin/service/activity": "社区活动",
  "/admin/service/activity/addevent": "添加活动",
  "/admin/service/notice/editevent": "修改活动",
  "/admin/service/notice/detailevent": "活动详情",
  "/admin/service/notice/sign": "报名列表",
  "/admin/service/vote": "投票活动",
  "/admin/service/vote/addvote": "添加投票",
  "/admin/service/vote/detailvote": "投票详情",
  "/admin/service/vote/editvote": "修改投票",
  "/admin/service/vote/voteresult": "投票结果",
  "/admin/service/vote/voteresult/detail": "投票详情",
  "/admin/service/phone": "服务电话",
  "/admin/service/phone/class": "分类管理",
  "/admin/parking": "停车管理",
  "/admin/parking/manager": "停车场管理",
  "/admin/parking/position": "车位管理",
  "/admin/parking/car": "业主车辆",
  "/admin/parking/record": "进出场记录",
  "/admin/parking/list": "黑白名单",
  "/admin/charge": "收费管理",
  "/admin/charge/meter": "抄表管理",
  "/admin/charge/setup": "费用设置",
  "/admin/charge/setup/room": "绑定房屋",
  "/admin/charge/setup/car": "绑定汽车",
  "/admin/charge/setup/parking": "绑定车位",
  "/admin/charge/house": "房屋收费",
  "/admin/charge/house/arrears": "欠费",
  "/admin/charge/house/bill": "费用明细",
  "/admin/charge/house/prestore": "预存",
  "/admin/charge/print": "打印小票",
  "/admin/charge/quittance": "打印收据",
  "/admin/charge/house/bill/handle": "费用缴费",
  "/admin/charge/car": "车辆收费",
  "/admin/charge/car/bill": "查看费用",
  "/admin/charge/parking-position": "车位收费",
  "/admin/charge/parking-position/bill": "查看费用",
  "/admin/charge/arrears": "物业费预缴设置",
  "/admin/charge/setting": "催缴设置",
  "/admin/charge/should-bill": "应收账单",
  "/admin/charge/payed-bill": "已缴账单",
  "/admin/charge/scrap-bill": "废弃账单",
  "/admin/charge/payment-bill": "缴费订单",
  "/admin/charge/payment-bill/detail": "账单列表",
  "/admin/account": "用户管理",
  "/admin/account/roles": "权限组",
  "/admin/account/roles/rolelist": "权限",
  "/admin/account/roles/roleuser": "成员",
  "/admin/account/roles/addrole": "添加权限组",
  "/admin/account/roles/editrole": "修改权限组",
  "/admin/account/list": "用户",
  "/admin/account/list/adduser": "添加用户",
  "/admin/account/list/edituser": "修改用户",
  "/admin/account/department": "部门",
  "/admin/fix": "报事报修",
  "/admin/fix/type": "报修类型",
  "/admin/fix/online": "在线报修",
  "/admin/fix/online/order-detail": "详情",
  "/admin/fix/dealt": "报修待办",
  "/admin/fix/dealt/order-detail": "详情",
  "/admin/fix/return-visit": "报修回访",
  "/admin/fix/return-visit/order-detail": "详情",
  "/admin/complaint": "投诉建议",
  "/admin/complaint/new/detail": "详情",
  "/admin/complaint/new": "投诉录入",
  "/admin/complaint/handle": "投诉受理",
  "/admin/complaint/handle/detail": "详情",
  "/admin/complaint/return-visit": "投诉回访",
  "/admin/complaint/return-visit/detail": "详情",
  "/admin/house": "房屋租赁",
  "/admin/house/manager": "房屋管理",
  "/admin/house/manager/create": "创建",
  "/admin/house/manager/details": "详情",
  "/admin/house/manager/check": "审核",
  "/admin/house/manager/assigning": "经纪人管理",
  "/admin/house/sell": "房屋出售",
  "/admin/house/appointment": "预约看房",
  "/admin/setting": "系统设置",
  "/admin/setting/info": "基本信息",
  "/admin/customer-service": "在线客服",
  "/admin/device": "设备管理",
  "/admin/device/door": "门禁",
  "/admin/device/door/doorrecord": "开门记录",
  "/admin/device/door/visitorrecord": "访客留影",
  "/admin/device/door/command": "操作记录",
  "/admin/device/door/permission": "开门权限",
  "/admin/device/door/facemanager": "人脸管理",
  "/admin/device/door/ICmanager": "IC卡管理",
  "/admin/setting/password": "修改密码",
  "/admin/application": "功能应用",
  "/admin/application/application": "应用",
  "/admin/application/application/preview": "预览",
  "/admin/application/application/buy": "购买",
  "/admin/application/order": "应用订单",
  "/admin/application/owner": "已购订单",
  "/admin/msg": "短信套餐",
  "/admin/msg/msg_package": "套餐列表",
  "/amdin/msg/msg_package/buy": "购买",
  "/admin/msg/order": "短信订单",
  "/admin/msg/owner": "已购短信套餐",
  "/admin/msg/order/detail": "详情",
  "/admin/msg/owner/detail": "详情"
};

const IconFont = createFromIconfontCN({
  scriptUrl: ["//at.alicdn.com/t/c/font_3286328_u14ysbuzvc.js"]
});

export const routes: any = [
  {
    title: "系统首页",
    path: "/admin/index",
    component: HomePage,
    icon: <IconFont type="icon-shouye" />
  },
  {
    title: "系统消息",
    path: "/admin/message",
    component: Wrapper(SystemMessage),
    hideInMenu: true,
  },
  {
    title: "个人信息",
    path: "/admin/person",
    component: Wrapper(Person),
    hideInMenu: true,
  },
  {
    title: "住户管理",
    path: "/admin/owner",
    exact: true,
    icon: <IconFont type="icon-yezhuguanli" />,
    children: [
      {
        title: "住户信息",
        path: "/admin/owner/info",
        exact: true,
        component: Wrapper(OwnerList)
      },
      {
        title: "房屋",
        path: "/admin/owner/info/houseinfo",
        exact: true,
        hideInMenu: true,
        component: Wrapper(HouseInfo)
      },
      {
        title: "车辆",
        path: "/admin/owner/info/carinfo",
        exact: true,
        hideInMenu: true,
        component: Wrapper(CarInfo)
      },
      {
        title: "住户审核",
        path: "/admin/owner/examine",
        exact: true,
        component: Wrapper(OwnerExamine)
      }
    ]
  },
  {
    title: "楼盘管理",
    exact: true,
    path: "/admin/building",
    icon: <IconFont type="icon-loupanguanli" />,
    children: [
      {
        title: "楼栋管理",
        exact: true,
        path: "/admin/building/list",
        component: Wrapper(Buildings)
      },
      {
        title: "单元管理",
        exact: true,
        path: "/admin/building/unit",
        component: Wrapper(BuildingUnit)
      },
      {
        title: "房屋管理",
        exact: true,
        path: "/admin/building/house",
        component: Wrapper(BuildingHouse)
      },
      {
        title: "业主信息",
        path: "/admin/building/house/userlist",
        exact: true,
        hideInMenu: true,
        component: Wrapper(HouseholdUserlist)
      },
      {
        title: "楼栋管家",
        path: "/admin/building/house/manager",
        exact: true,
        hideInMenu: true,
        component: Wrapper(Manager)
      }
    ]
  },
  {
    title: "小区服务",
    path: "/admin/service",
    exact: true,
    icon: <IconFont type="icon-xiaoqufuwu" />,
    children: [
      {
        title: "社区邻里",
        path: "/admin/service/neighbor",
        exact: true,
        component: Wrapper(Neighbor)
      },
      {
        title: "文章列表",
        path: "/admin/service/neighbor/page-list",
        exact: true,
        hideInMenu: true,
        component: Wrapper(PageList),
      },
      {
        title: "详情",
        path: "/admin/service/neighbor/page-list/detail",
        exact: true,
        hideInMenu: true,
        component: Wrapper(ArticleDetail)
      },
      {
        title: "评论列表",
        path: "/admin/service/neighbor/comments",
        exact: true,
        hideInMenu: true,
        component: Wrapper(Comments)
      },
      {
        title: "公告通知",
        path: "/admin/service/notice",
        exact: true,
        component: Wrapper(Notice)
      },
      {
        title: "发布",
        path: "/admin/service/notice/addnotice",
        exact: true,
        hideInMenu: true,
        component: Wrapper(AddNotice)
      },
      {
        title: "修改",
        hideInMenu: true,
        path: "/admin/service/notice/editnotice",
        exact: true,
        component: Wrapper(EditNotice)
      },
      {
        title: "详情",
        hideInMenu: true,
        path: "/admin/service/notice/detailnotice",
        exact: true,
        component: Wrapper(DetailNotice)
      },
      {
        title: "社区活动",
        path: "/admin/service/activity",
        exact: true,
        component: Wrapper(Activity)
      },
      {
        title: "投票活动",
        path: "/admin/service/vote",
        exact: true,
        component: Wrapper(VoteList)
      },
      {
        title: "添加投票",
        path: "/admin/service/vote/addvote",
        exact: true,
        hideInMenu: true,
        component: Wrapper(AddVote)
      },
      {
        title: "投票详情",
        path: "/admin/service/vote/voteresult/detail",
        exact: true,
        hideInMenu: true,
        component: Wrapper(ResultDetail)
      },
      {
        title: "详情",
        path: "/admin/service/vote/detailvote",
        exact: true,
        hideInMenu: true,
        component: Wrapper(DetailVote)
      },
      {
        title: "修改投票",
        path: "/admin/service/vote/editvote",
        exact: true,
        hideInMenu: true,
        component: Wrapper(EditVote)
      },
      {
        title: "投票结果",
        path: "/admin/service/vote/voteresult",
        exact: true,
        hideInMenu: true,
        component: Wrapper(VoteResult)
      },
      {
        title: "添加活动",
        path: "/admin/service/activity/addevent",
        exact: true,
        hideInMenu: true,
        component: Wrapper(AddEvent)
      },
      {
        title: "修改活动",
        hideInMenu: true,
        path: "/admin/service/notice/editevent",
        exact: true,
        component: Wrapper(EditEvent)
      },
      {
        title: "详情",
        hideInMenu: true,
        path: "/admin/service/notice/detailevent",
        exact: true,
        component: Wrapper(DetailEvent)
      },
      {
        title: "报名列表",
        hideInMenu: true,
        path: "/admin/service/notice/sign",
        exact: true,
        component: Wrapper(EventSign)
      },
      {
        title: "服务电话",
        path: "/admin/service/phone",
        exact: true,
        component: Wrapper(Phone)
      },
      {
        title: "分类管理",
        path: "/admin/service/phone/class",
        hideInMenu: true,
        exact: true,
        component: Wrapper(PhoneClass)
      },
    ]
  },
  {
    title: "停车管理",
    path: "/admin/parking",
    exact: true,
    icon: <IconFont type="icon-tingcheguanli" />,
    children: [
      {
        title: "停车场管理",
        path: "/admin/parking/manager",
        exact: true,
        component: Wrapper(ParkingList)
      },
      {
        title: "车位管理",
        path: "/admin/parking/position",
        exact: true,
        component: Wrapper(ParkingPosition)
      },
      {
        title: "业主车辆",
        path: "/admin/parking/car",
        exact: true,
        component: Wrapper(ParkingCar)
      }
      // {
      //   title: '进出场记录',
      //   path: '/admin/parking/record',
      //   exact: true,
      //   component: Wrapper(OwnerExamine)
      // },
      // {
      //   title: '黑白名单',
      //   path: '/admin/parking/list',
      //   exact: true,
      //   component: Wrapper(OwnerExamine)
      // }
    ]
  },
  {
    title: "收费管理",
    path: "/admin/charge",
    exact: true,
    icon: <IconFont type="icon-gyshoufeiguanli" />,
    children: [
      {
        title: "抄表管理",
        path: "/admin/charge/meter",
        exact: true,
        component: Wrapper(Meter)
      },
      {
        title: "费用设置",
        path: "/admin/charge/setup",
        exact: true,
        component: Wrapper(ChargeSetup)
      },
      {
        title: "绑定房屋",
        path: "/admin/charge/setup/room",
        exact: true,
        hideInMenu: true,
        component: Wrapper(ChargeSetupBindRoom)
      },
      {
        title: "绑定汽车",
        path: "/admin/charge/setup/car",
        exact: true,
        hideInMenu: true,
        component: Wrapper(ChargeSetupBindCar)
      },
      {
        title: "绑定车位",
        path: "/admin/charge/setup/parking",
        exact: true,
        hideInMenu: true,
        component: Wrapper(ChargeSetupBindParking)
      },
      {
        title: "房屋收费",
        path: "/admin/charge/house",
        exact: true,
        component: Wrapper(HouseCharge)
      },
      {
        title: "欠费",
        path: "/admin/charge/house/arrears",
        exact: true,
        hideInMenu: true,
        component: Wrapper(HouseArrears)
      },
      {
        title: "费用明细",
        path: "/admin/charge/house/bill",
        exact: true,
        hideInMenu: true,
        component: Wrapper(HouseBill)
      },
      {
        title: "预存",
        path: "/admin/charge/house/prestore",
        exact: true,
        hideInMenu: true,
        component: Wrapper(HouseBillPrestore)
      },
      {
        title: "打印小票",
        path: "/admin/charge/print",
        exact: true,
        hideInMenu: true,
        component: Wrapper(PrintReceipt)
      },
      {
        title: "打印收据",
        path: "/admin/charge/quittance",
        exact: true,
        hideInMenu: true,
        component: Wrapper(Quittance)
      },
      {
        title: "费用缴费",
        path: "/admin/charge/house/bill/handle",
        exact: true,
        hideInMenu: true,
        component: Wrapper(HouseBillHandle)
      },
      {
        title: "车辆收费",
        path: "/admin/charge/car",
        exact: true,
        component: Wrapper(CarCharge)
      },
      {
        title: "查看费用",
        path: "/admin/charge/car/bill",
        exact: true,
        hideInMenu: true,
        component: Wrapper(CarChargeBill)
      },
      {
        title: "车位收费",
        path: "/admin/charge/parking-position",
        exact: true,
        component: Wrapper(ChargeParkingPosition)
      },
      {
        title: "查看费用",
        path: "/admin/charge/parking-position/bill",
        exact: true,
        hideInMenu: true,
        component: Wrapper(ChargeParkingPositionBill)
      },
      {
        title: "物业费预缴设置",
        path: "/admin/charge/arrears",
        exact: true,
        component: Wrapper(Arrears)
      },
      {
        title: "催缴设置",
        path: "/admin/charge/setting",
        exact: true,
        component: Wrapper(ChargeSetting)
      },
      {
        title: "应收账单",
        path: "/admin/charge/should-bill",
        exact: true,
        component: Wrapper(ShouldBill)
      },
      {
        title: "已缴账单",
        path: "/admin/charge/payed-bill",
        exact: true,
        component: Wrapper(PayBill)
      },
      {
        title: "废弃账单",
        path: "/admin/charge/scrap-bill",
        exact: true,
        component: Wrapper(ScrapBill)
      },
      {
        title: "缴费订单",
        path: "/admin/charge/payment-bill",
        exact: true,
        component: Wrapper(PaymentBill)
      },
      {
        title: "账单列表",
        path: "/admin/charge/payment-bill/detail",
        exact: true,
        hideInMenu: true,
        component: Wrapper(PaymentBillDetail)
      }
    ]
  },
  {
    title: "用户管理",
    path: "/admin/account",
    exact: true,
    icon: <IconFont type="icon-yonghuguanli" />,
    children: [
      {
        title: "权限组",
        path: "/admin/account/roles",
        exact: true,
        component: Wrapper(UserRoles),
      },
      {
        title: "用户",
        path: "/admin/account/list",
        exact: true,
        component: Wrapper(UserList)
      },
      {
        title: "部门",
        path: "/admin/account/department",
        exact: true,
        component: Wrapper(Department)
      },
      {
        title: "成员",
        path: "/admin/account/roles/roleuser",
        eaxct: true,
        hideInMenu: true,
        component: Wrapper(RoleUser)
      },
      {
        title: "权限",
        path: "/admin/account/roles/rolelist",
        exact: true,
        hideInMenu: true,
        component: Wrapper(RoleList),
      },
      {
        title: "添加权限组",
        path: "/admin/account/roles/addrole",
        exact: true,
        hideInMenu: true,
        component: Wrapper(AddRole)
      }, {
        title: "修改权限组",
        path: "/admin/account/roles/editrole",
        exact: true,
        hideInMenu: true,
        component: Wrapper(EditRole)
      },
      {
        title: "添加用户",
        path: "/admin/account/list/adduser",
        exact: true,
        hideInMenu: true,
        component: Wrapper(AddUser)
      },
      {
        title: "修改用户",
        path: "/admin/account/list/edituser",
        exact: true,
        hideInMenu: true,
        component: Wrapper(EditUser)
      }
    ]
  },
  {
    title: "报事报修",
    path: "/admin/fix",
    exact: true,
    icon: <IconFont type="icon-baoshibaoxiu" />,
    children: [
      {
        title: "报修类型",
        path: "/admin/fix/type",
        exact: true,
        component: Wrapper(FixType)
      },
      {
        title: "在线报修",
        path: "/admin/fix/online",
        exact: true,
        component: Wrapper(FixOnlineForm)
      },
      {
        title: "详情",
        path: "/admin/fix/online/order-detail",
        exact: true,
        component: Wrapper(FixOrderDetail),
        hideInMenu: true
      },
      {
        title: "详情",
        path: "/admin/fix/dealt/order-detail",
        exact: true,
        component: Wrapper(FixOrderDetail),
        hideInMenu: true
      },
      {
        title: "报修待办",
        path: "/admin/fix/dealt",
        exact: true,
        component: Wrapper(FixTodo)
      },
      {
        title: "报修回访",
        path: "/admin/fix/return-visit",
        exact: true,
        component: Wrapper(FixReturnVisit)
      },
      {
        title: "详情",
        path: "/admin/fix/return-visit/order-detail",
        exact: true,
        component: Wrapper(FixOrderDetail),
        hideInMenu: true
      },
    ]
  },
  {
    title: "投诉建议",
    path: "/admin/complaint",
    exact: true,
    icon: <IconFont type="icon-tousujianyi" />,
    children: [
      {
        title: "详情",
        path: "/admin/complaint/new/detail",
        exact: true,
        component: Wrapper(ComplaintDetail),
        hideInMenu: true
      },
      {
        title: "投诉录入",
        path: "/admin/complaint/new",
        exact: true,
        component: Wrapper(Complaint)
      },
      {
        title: "投诉受理",
        path: "/admin/complaint/handle",
        exact: true,
        component: Wrapper(ComplaintHandle)
      },
      {
        title: "详情",
        path: "/admin/complaint/handle/detail",
        exact: true,
        component: Wrapper(ComplaintDetail),
        hideInMenu: true
      },
      {
        title: "投诉回访",
        path: "/admin/complaint/return-visit",
        exact: true,
        component: Wrapper(ComplaintReturnVisit)
      }, {
        title: "详情",
        path: "/admin/complaint/return-visit/detail",
        exact: true,
        component: Wrapper(ComplaintDetail),
        hideInMenu: true
      },
    ]
  },
  {
    title: "租赁管理",
    path: "/admin/house",
    exact: true,
    icon: <IconFont type="icon-fangwuzushou" />,
    children: [
      {
        title: "房屋管理",
        path: "/admin/house/manager",
        exact: true,
        component: Wrapper(HouseLeaseManager)
      },
      {
        title: "房屋租赁-创建",
        path: "/admin/house/manager/create",
        exact: true,
        hideInMenu: true,
        component: Wrapper(HouseLeaseCreate)
      },
      {
        title: "房屋租赁-详情",
        path: "/admin/house/manager/details",
        exact: true,
        hideInMenu: true,
        component: Wrapper(HouseDetails)
      },
      {
        title: "房屋租赁-审核",
        path: "/admin/house/manager/check",
        expect: true,
        hideInMenu: true,
        component: Wrapper(HouseCheck)
      },
      {
        title: "分配经纪人",
        path: "/admin/house/manager/assigning",
        expect: true,
        hideInMenu: true,
        component: Wrapper(Broker)
      },
      {
        title: "预约看房",
        path: "/admin/house/appointment",
        exact: true,
        component: Wrapper(AppointmentHouse)
      },
      // {
      //   title: "房屋出售",
      //   path: "/admin/house/sell",
      //   exact: true,
      //   component: Wrapper(OwnerExamine)
      // },
      // {
      //   title: "车位租赁",
      //   path: "/admin/parking/lease",
      //   exact: true,
      //   component: Wrapper(OwnerExamine)
      // },
      // {
      //   title: "车位出售",
      //   path: "/admin/parking/sell",
      //   exact: true,
      //   component: Wrapper(OwnerExamine)
      // }
    ]
  },
  {
    title: "设备管理",
    path: "/admin/device",
    exact: true,
    icon: <IconFont type="icon-shebeiguanli" />,
    children: [
      {
        title: "门禁",
        path: "/admin/device/door",
        exact: true,
        component: Wrapper(DoorControl)
      },
      {
        title: "开门权限",
        path: "/admin/device/door/permission",
        exact: true,
        hideInMenu: true,
        component: Wrapper(DoorPermission)
      },
      {
        title: "人脸管理",
        path: "/admin/device/door/facemanager",
        exact: true,
        hideInMenu: true,
        component: Wrapper(FaceManager)
      },
      {
        title: "IC卡管理",
        path: "/admin/device/door/ICmanager",
        exact: true,
        hideInMenu: true,
        component: Wrapper(ICManager)
      },
      {
        title: "操作记录",
        path: "/admin/device/door/command",
        exact: true,
        hideInMenu: true,
        component: Wrapper(Command)
      },
      {
        title: "开门记录",
        path: "/admin/device/door/doorrecord",
        exact: true,
        hideInMenu: true,
        component: Wrapper(DoorRecord)
      },
      {
        title: "访客留影",
        path: "/admin/device/door/visitorrecord",
        exact: true,
        hideInMenu: true,
        component: Wrapper(VisitroRecord)
      }
      // {
      //   title: "道闸",
      //   path: "/admin/device/brake",
      //   exact: true,
      //   component: Wrapper(CompanyInfo)
      // },
      // {
      //   title: "视频监控",
      //   path: "/admin/device/video-monitor",
      //   exact: true,
      //   component: Wrapper(CompanyInfo)
      // }
    ]
  },
  // {
  //   title: "控制台",
  //   path: "/admin/console",
  //   exact: true,
  //   icon: <IconFont type="icon-kongzhitai" />,
  //   children: [
  //     {
  //       title: "收银台",
  //       path: "/admin/console/cashier-desk",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "房产查询",
  //       path: "/admin/console/house",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "车辆查询",
  //       path: "/admin/device/vehicle",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     }
  //   ]
  // },
  {
    title: "功能应用",
    path: "/admin/application",
    exact: true,
    icon: <IconFont type="icon-yingyong" />,
    children: [
      {
        title: "应用",
        path: "/admin/application/application",
        exact: true,
        component: Wrapper(Application)
      },
      {
        title: "预览",
        path: "/admin/application/application/preview",
        exact: true,
        hideInMenu: true,
        component: Wrapper(Preview)
      },
      {
        title: "购买",
        path: "/admin/application/application/buy",
        exact: true,
        hideInMenu: true,
        component: Wrapper(BuyApplication)
      },
      {
        title: "应用订单",
        path: "/admin/application/order",
        exact: true,
        component: Wrapper(OrderList)
      },
      {
        title: "已购应用",
        path: "/admin/application/owner",
        exact: true,
        component: Wrapper(OwnerApplication)
      },
    ]
  },
  {
    title: "短信套餐",
    path: "/admin/msg",
    exact: true,
    icon: <IconFont type="icon-duanxin" />,
    children: [
      {
        title: "套餐列表",
        path: "/admin/msg/msg_package",
        exact: true,
        component: Wrapper(Msg_package)
      },
      {
        title: "购买",
        path: "/admin/msg/msg_package/buy",
        exact: true,
        hideInMenu: true,
        component: Wrapper(BuyMsg)
      },
      {
        title: "短信订单",
        path: "/admin/msg/order",
        exact: true,
        component: Wrapper(OrderMsg)
      },
      {
        title: "已购短信套餐",
        path: "/admin/msg/owner",
        exact: true,
        component: Wrapper(OwnerMsg)
      },
      {
        title: "详情",
        path: "/admin/msg/order/detail",
        exact: true,
        hideInMenu: true,
        component: Wrapper(Msg_Detail)
      },
      {
        title: "详情",
        path: "/admin/msg/owner/detail",
        exact: true,
        hideInMenu: true,
        component: Wrapper(Msg_Detail)
      },
    ]
  },
  {
    title: "系统设置",
    path: "/admin/setting",
    exact: true,
    icon: <IconFont type="icon-xitongshezhi" />,
    children: [
      {
        title: "基本信息",
        path: "/admin/setting/info",
        exact: true,
        component: Wrapper(CompanyInfo)
      },
      {
        title: "修改密码",
        path: "/admin/setting/password",
        exact: true,
        hideInMenu: true,
        component: Wrapper(EditPassword)
      }
    ]
  },
  {
    title: "在线客服",
    path: "/admin/customer-service",
    exact: true,
    component: Wrapper(CustomerService),
    icon: <IconFont type="icon-zaixiankefu" />
  },
  // {
  //   title: "协同办公",
  //   path: "/admin/cooperative",
  //   exact: true,
  //   icon: <IconFont type="icon-a-xietongbangong1" />,
  //   children: [
  //     {
  //       title: "流程实例",
  //       path: "/admin/cooperative/flow",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "审批",
  //       path: "/admin/cooperative/approve",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "考勤",
  //       path: "/admin/cooperative/cheking-in",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "日程",
  //       path: "/admin/cooperative/schedule",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     }
  //   ]
  // },
  // {
  //   title: "巡检管理",
  //   path: "/admin/polling",
  //   exact: true,
  //   icon: <IconFont type="icon-xunjianguanli" />,
  //   children: [
  //     {
  //       title: "巡检点",
  //       path: "/admin/polling/point",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "巡检路线",
  //       path: "/admin/polling/line",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "巡检计划",
  //       path: "/admin/polling/plan",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "巡检任务",
  //       path: "/admin/polling/task",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "巡检明细",
  //       path: "/admin/polling/detail",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     }
  //   ]
  // },
  // {
  //   title: "合同管理",
  //   path: "/admin/contract",
  //   exact: true,
  //   icon: <IconFont type="icon-hetongguanli" />,
  //   children: [
  //     {
  //       title: "合同类型",
  //       path: "/admin/contract/type",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "合同甲方",
  //       path: "/admin/contract/owner",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "起草合同",
  //       path: "/admin/contract/draft",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "合同查询",
  //       path: "/admin/contract/query",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "合同变更",
  //       path: "/admin/contract/modify",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "合同到期",
  //       path: "/admin/contract/expired",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     }
  //   ]
  // },
  // {
  //   title: "采购管理",
  //   path: "/admin/purchase",
  //   exact: true,
  //   icon: <IconFont type="icon-caigouguanli" />,
  //   children: [
  //     {
  //       title: "仓库信息",
  //       path: "/admin/purchase/warehouse",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "物品信息",
  //       path: "/admin/purchase/goods-info",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "物品类型",
  //       path: "/admin/purchase/goods-type",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "物品供应商",
  //       path: "/admin/purchase/goods-provider",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "物品规格",
  //       path: "/admin/purchase/goods-specification",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "采购申请",
  //       path: "/admin/purchase/apply",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "调拔记录",
  //       path: "/admin/purchase/allot-record",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "出入库明细",
  //       path: "/admin/purchase/out-and-in-warehouse-detail",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "调拔明细",
  //       path: "/admin/purchase/allot-detail",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "物品领用",
  //       path: "/admin/purchase/goods-receive",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "转赠记录",
  //       path: "/admin/purchase/given-record",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     },
  //     {
  //       title: "物品使用记录",
  //       path: "/admin/setting/goods-use-record",
  //       exact: true,
  //       component: Wrapper(CompanyInfo)
  //     }
  //   ]
  // }
];

export const staticRoutes = [
  {
    title: "登录",
    path: "/login",
    component: Login
  }
]; 
