import * as React from 'react'
import { BrowserRouter, Switch, Route, Redirect } from 'react-router-dom'
import AdminLayout from '../layout/index'
import Login from '../views/User/Login/Login'
import { isLogined } from '../utils/auth'

const Router: React.FC = () => {
  return isLogined() ?
    <BrowserRouter>
      <Switch>
        <Route path="/" render={(props => <AdminLayout {...props}
        />)} />
      </Switch>
    </BrowserRouter>
    :
    <BrowserRouter>
      <Switch>
        <Route path='/login' component={Login} />
        <Redirect from='/*' to='/login' />
      </Switch>
    </BrowserRouter>
}

export default Router