import request from "./request"

export const BuildingHouse = params => {
  const config = {
    url: '/buildings/house',
    method: params.method || 'get'
  }
  config[!['get', 'delete'].includes(config.method) ? 'data' : 'params'] = params
  return request(config)
}

export const Building = params => {
  const config = {
    url: '/buildings/building',
    method: params.method || 'get'
  }
  config[!['get', 'delete'].includes(config.method) ? 'data' : 'params'] = params
  return request(config)
}

export const BuildingUnit = params => {
  const config = {
    url: '/buildings/unit',
    method: params.method || 'get'
  }
  config[!['get', 'delete'].includes(config.method) ? 'data' : 'params'] = params
  return request(config)
}
// 批量楼栋导入
export const BuildingsImport = ({ file }) => request({
  url: '/buildings/building/import',
  method: 'post',
  data: file
})
// 获取楼栋导入模板 /api/v1/buildings/building/template
export const GetBuildingTemplate = () => request({
  url: '/buildings/building/template',
  method: 'get'
})
// 批量单元导入
export const BuildingsUnitImport = ({ file }) => request({
  url: '/buildings/unit/import',
  method: 'post',
  data: file
})
// 获取单元导入模板 /api/v1/buildings/unit/template
export const GetBuildingUnitTemplate = () => request({
  url: '/buildings/unit/template',
  method: 'get'
})
// 批量房屋导入 /api/v1/buildings/house/import
export const BuildingsHouseImport = ({ file }) => request({
  url: '/buildings/house/import',
  method: 'post',
  data: file
})
// 获取房屋导入模板 /api/v1/buildings/house/template
export const GetBuildingHouseTemplate = () => request({
  url: '/buildings/house/template',
  method: 'get'
})
///api/v1/buildings/manager 楼栋管家
export const BuildingManager = params => {
  const config = {
    url: '/buildings/manager',
    method: params.method || 'get'
  }
  config[!['get', 'delete',""].includes(config.method) ? 'data' : 'params'] = params
  return request(config)
}