import request from "./request";

//获取门禁列表
export const GetDoorControl = params => request({
    url: '/gate',
    method: 'get',
    params
})
///api/v1/gate/set 门禁配置进场场和位置
export const SetGate = data => request({
    url: "/gate/set",
    method: 'PUT',
    data
})
///api/v1/gate/enable 门禁起停用
export const GateEnable = data => request({
    url: "/gate/enable",
    method: "put",
    data
})
///api/v1/gate/white/household 白名单列表（用户）
export const GetHousehold = params => request({
    url: "/gate/white/household",
    method: 'GET',
    params
})
///api/v1/gate/white/card 白名单列表（ic卡）
export const GetCard = params => request({
    url: "/gate/white/card",
    method: 'GET',
    params
})
///api/v1/gate/white 门禁白名单添加 //删除
export const HandleWhite = params => {
    const config = {
        url: '/gate/white',
        method: params.method
    }
    config[['post'].includes(config.method) ? 'data' : 'params'] = params
    return request(config)
}
///api/v1/gate/command/open 门禁远程开门
export const Open = data => request({
    url: "/gate/command/open",
    method: "POST",
    data
})
///api/v1/gate/command/restart 门禁重启
export const Restart = data => request({
    url: "/gate/command/restart",
    method: "post",
    data
})
// /api/v1/gate/command 操作记录
export const CommandList = params => request({
    url: "/gate/command",
    method: "get",
    params
})
///api/v1/gate/record 开门记录
export const Record = params => request({
    url: "/gate/record",
    method: "GET",
    params
})
///api/v1/gate/visitor 访客记录
export const Visitor = params => request({
    url: "/gate/visitor",
    method: "GET",
    params
})
///api/v1/gate/white/sync 门禁手动同步白名单
export const Sync = data => request({
    url: "/gate/white/sync",
    method: "PUT",
    data
})
///api/v1/gate/pic 人脸列表
export const FaceList = params => {
    const config = {
        url: '/gate/pic',
        method: params.method
    }
    config[['put'].includes(config.method) ? 'data' : 'params'] = params
    return request(config)
}
///api/v1/gate/pic/approve 人脸审核
export const FaceApprove = data => request({
    url: "/gate/pic/approve",
    method: "PUT",
    data
})
//api/v1/gate/card IC卡操作
export const IcOption = params => {
    const config = {
        url: '/gate/card',
        method: params.method
    }
    config[['post','put'].includes(config.method) ? 'data' : 'params'] = params
    return request(config)
}
///api/v1/gate/card/devices 卡还可以绑定的设备
export const CardDevices = params =>request({
    url:"/gate/card/devices",
    params
})
///api/v1/gate/unit 门禁单元列表
export const GateUnit = params => {
    const config = {
        url: '/gate/unit',
        method: params.method
    }
    config[['post','put'].includes(config.method) ? 'data' : 'params'] = params
    return request(config)
}