import React, { useEffect, useState } from "react";
import { ApplicationList } from "../../services/application";
import { Button, Image } from "antd";
import "./application.scss"
import { Link } from "react-router-dom";

const Application = () => {
    const [list, setList]: any = useState({
        data: []
    })
    useEffect(() => {
        getList()
    }, [])
    const getList = async () => {
        const { data } = await ApplicationList({ page: -1, page_size: -1 });
        setList(pre => ({ ...pre, data }))
    }
    return (<>
        <div className="application_main">
            {list.data.map(item => {
                return <div key={item.id} className="application_content">
                    <div className="top_content">
                        <Image src={item.icon} style={{ height: "50px", width: "50px" }} />
                        <div className="application_desc">
                            <div style={{fontSize:"18px",fontWeight:"bolder",width:"9rem"}}>{item.name}</div>
                            <div className="application_desc_content" title={item.desc}>{item.desc}</div>
                        </div>
                    </div>
                    <div className="bottom_content">
                        <Link to={{pathname:"/admin/application/application/buy",state:item}}>
                            <Button type="primary">购买</Button>
                        </Link>
                        <Link to={{ pathname: "/admin/application/application/preview", state: item }}>
                            <Button type="primary">详情</Button>
                        </Link>
                    </div>
                </div>
            })}
        </div>
    </>)
}

export default Application