import { Button, Row } from "antd";
import React, { useEffect } from "react";
import type { ActionType } from "@ant-design/pro-table";
import ProTable from "@ant-design/pro-table";
import { OrderApplication, GetAllApt } from "../../services/application";
import { Link } from "react-router-dom";

const OrderList = () => {
    const columns: any = [
        {
            title: "小区名",
            align: "center",
            search: false,
            dataIndex: "garden_name"
        },
        {
            title: "应用名",
            align: "center",
            search: false,
            dataIndex: "name"
        },
        {
            title: "订单金额",
            align: "center",
            search: false,
            dataIndex: "amount",
            render: (_, row) => (row.amount / 100).toFixed(2)
        },
        {
            title: "状态",
            align: "center",
            dataIndex: "status",
            valueEnum: {
                1: { text: "待审核", status: "Processing" },
                2: { text: "已通过", status: "Success" },
                3: { text: "未通过", status: "Error" }
            }
        },
        {
            title: "操作",
            align: "center",
            search: false,
            dataIndex: "option",
            render: (_, row) => <Link to={{pathname:"/admin/application/application/preview",state:row}}>
                <Button type="link">应用详情</Button>
            </Link>
        }
    ]
    const actionRef: any = React.useRef<ActionType>();

    return (<>
        <ProTable
            actionRef={actionRef}
            rowKey="order_id"
            request={GetAllApt}
            columns={columns}
        />
    </>)
}

export default OrderList