import React, { useEffect, useState } from "react";
import { GetAllApt } from "../../services/application";
import { Button, Image } from "antd";
import "./application.scss"
import { Link } from "react-router-dom";

const OwnerApplication = () => {
    const [list, setList]: any = useState({
        data: []
    })
    useEffect(() => {
        getList()
    }, [])
    const getList = async () => {
        const { data } = await GetAllApt({ page: -1, pagesize: -1, status: 2 });
        setList(pre => ({ ...pre, data }))
    }
    return (<>
        {list.data.length == 0 ? 
        <>
        <h1>暂无数据</h1>
        </>
        :
            <div className="application_main">
                {list.data.map(item => {
                    return <div key={item.order_id} className="application_content">
                        <div className="top_content">
                            <Image src={item.icon} style={{ height: "50px", width: "50px" }} />
                            <div className="application_desc">
                                <div>应用名：{item.name}</div>
                                <div>应用简介：{item.desc}</div>
                            </div>
                        </div>
                        <div className="bottom_content">
                            <Link to={{ pathname: "/admin/application/application/preview", state: item }}>
                                <Button type="primary">详情</Button>
                            </Link>
                        </div>
                    </div>
                })}
            </div>
        }
    </>)
}

export default OwnerApplication