import React from "react";
import { GetChargeOrderInfo } from "../../services/charge";
import { useHistory } from "react-router";
import ProTable, { ActionType } from "@ant-design/pro-table"
import { CHARGE_TYPES } from "../../CONSTANT";
import { Button } from "antd";
import moment from 'moment'

const PaymentBillDetail = () => {
    const history = useHistory();
    const location: any = history.location;
    const { order_id } = location.state;
    const actionRef: any = React.useRef<ActionType>();
    const columns: any = [
        {
            title: "房间/车位/车辆",
            dataIndex: "obj_name"
        },
        {
            title: "费项名称",
            dataIndex: "charge_name"
        },
        {
            title: "费用类型",
            dataIndex: "charge_type",
            valueEnum: CHARGE_TYPES
        },
        {
            title: "滞纳金",
            dataIndex: "late_fee",
            render: (_, row) => row.late_fee / 100
        },
        {
            title: "应收金额",
            dataIndex: "amount",
            render: (_, row) => row.amount / 100
        },
        {
            title: "上期读数",
            dataIndex: "last_used"
        },
        {
            title: "本期读数",
            dataIndex: "current_used"
        },
        {
            title: "费用描述",
            dataIndex: "charge_desc",
            ellipsis: true,
        },
        {
            title: "开始时间",
            dataIndex: "start",
        },
        {
            title: "结束时间",
            dataIndex: "end",
        },
    ]
    return <>
        <ProTable
            actionRef={actionRef}
            rowKey="bill_id"
            columns={columns}
            request={GetChargeOrderInfo}
            params={{ order_id }}
            search={false}
            pagination={false}
            toolBarRender={() => [
                <Button type='primary' onClick={history.goBack}>返回</Button>
            ]}
        />
    </>
}

export default PaymentBillDetail