import { Form, Button } from "antd";
import React, { useEffect, useState } from "react";
import { useHistory } from "react-router";
import { getTicketList } from "../../../redux/action/ticket";
import { connect } from "react-redux";
import "./print.scss"

const ComponentToPrint = React.forwardRef((props: any, ref: any) => {
    const history = useHistory()
    const location = history.location
    const order_id: any = location.state

    useEffect(() => {
        props.getTicketList({ order_id })
    }, [])
    const List = [
        { label: "房号", value: "obj_name" },
        { label: "时间", value: "pay_time" },
    ]
    return (
        <div ref={ref} className="printPad">
            <h1>缴费收据单</h1>
            ***********************

            <Form wrapperCol={{ span: 8 }} labelAlign='left' className="ticket_info">
                <Form.Item label="单号">
                    <span>{order_id}</span>
                </Form.Item>
                {List.map(item => {
                    return <Form.Item label={item.label} key={item.label}>
                        {props.ticket_info.map(key => {
                            return key[item.value]
                        })}
                    </Form.Item>
                })}
            </Form>
            ***********************
            <Form wrapperCol={{ span: 8 }} labelAlign='left' className="ticket_info">
                <Form.Item label="收费项目">
                    {props.ticket_info.map(key => {
                        return key.charge_name
                    })}
                </Form.Item>
                <Form.Item label="收费范围">
                    {props.ticket_info.map(key => {
                        return `${key.start}至${key.end}`
                    })}
                </Form.Item>
                <Form.Item label="单价/固定费">
                    {props.ticket_info.map(key => {
                        return `${key.unit_price}/${key.fix_amount}`
                    })}
                </Form.Item>
                <Form.Item label="面积/用量">
                    {props.ticket_info.map(key => {
                        return key.area_used
                    })}
                </Form.Item>
                <Form.Item label="金额">
                    {props.ticket_info.map(key => {
                        return key.amount
                    })}
                </Form.Item>
                <Form.Item label="备注">
                    {props.ticket_info.map(key => {
                        return key.comment
                    })}
                </Form.Item>
            </Form>
            ***********************
            <Form>
                <Form.Item label="总计">
                    {props.ticket_info.map(key => {
                        return key.should_pay_amount
                    })}
                </Form.Item>
            </Form>
        </div>
    );
});


const mapStateToProps = (state) => {
    return {
        ticket_info: state.getTicketInfo.list,
    }
}

const mapDispatchToProps = (dispatch) => {
    return {
        getTicketList: (userInput) => dispatch(getTicketList(userInput)),
    }
}

export default connect(mapStateToProps, mapDispatchToProps,null,{ forwardRef: true})(ComponentToPrint)