import React, { useEffect, useState, useRef, useMemo } from "react";
import {
    Col, Row, Image, Badge, Dropdown, Menu, Popconfirm, message, Avatar, Divider,
    Upload
} from 'antd';
import moment from 'moment'
import {
    CbEvents
} from 'open-im-sdk'
import { connect } from "react-redux";
import { UserOutlined, SmileOutlined, PictureOutlined } from "@ant-design/icons";
import { getDateDiff } from "../../utils/utils";
import openIM from "../../utils/openIM";
import { setIMlist } from "../../redux/action/userinfo";
import { GetOpen_Info, GetMateral_info } from '../../services/user';
import './index.scss'
import { Link } from "react-router-dom";

const CustomerService = (props) => {
    const messagesEnd: any = useRef<HTMLDivElement>(null);
    const myref: any = useRef<HTMLDivElement>(null);
    const [messageList, setMessageList]: any = useState([]);
    const [conversationID, setconversationID]: any = useState();
    const [now, setNow]: any = useState();
    const [userID, setuserID]: any = useState();
    const [hasMore, sethasMore] = useState(false);
    const [showName, setshowName]: any = useState("");
    const [newMessage, setNewMessage]: any = useState({});
    const [currentIndex, setcurrentIndex]: any = useState();
    useEffect(() => {
        const now = new Date().valueOf()
        setNow(now);
        if (userID) {
            let index = props.imList.findIndex((item) => item.userID === userID);
            setcurrentIndex(index);
        }
        console.log("会话列表改变", props);
    }, [props.imList]);
    const confirm = (e) => {
        openIM.deleteConversation(conversationID).then(res => {
            let newChatList = props.imList.filter(item => item.conversationID !== conversationID);
            props.setIMList(newChatList);
            let str = newChatList.map(item => {
                return { ...item, latestMsg: JSON.stringify(item.latestMsg) }
            })
            if (conversationID == `single_${userID}`) {
                setMessageList([]);
                setshowName('');
                setcurrentIndex();
                setuserID();
            }
            sessionStorage.setItem("chatList", JSON.stringify(str));
            message.success('删除成功');
        })
    };
    const getHistoryMessage = (flag, id) => {
        sethasMore(false);
        const options = {
            groupID: "",
            startClientMsgID: flag ? messageList[0].clientMsgID : '',
            count: 12,
            userID: id,
        }
        openIM.getHistoryMessageList(options).then(({
            data
        }) => {
            let result = JSON.parse(data);
            const newMessageList: any = [];
            if (result.length > 0) {
                result.forEach((item, index) => {
                    if ([102, 108].includes(item.contentType)) {
                        item.content = JSON.parse(item.content)
                    }
                    if (index == 0) {
                        newMessageList.push({
                            ...item,
                            showTime: true,
                        })
                    } else {
                        const current = result[index].sendTime;
                        let minutes;
                        const lastShowTime = result[index - 1].sendTime;
                        minutes = (current - lastShowTime) / 1000 / 60;
                        if (minutes > 5) {
                            newMessageList.push({
                                ...item,
                                showTime: true,
                            })
                        } else {
                            newMessageList.push({
                                ...item,
                                showTime: false,
                            })
                        }
                    }
                })
            } else {
                sethasMore(true);
                message.info("没有更多消息了！")
            }
            if (result.length < 12) {
                sethasMore(true);
            }
            if (!flag) {
                setMessageList(newMessageList);
                readMessage(id);
                setuserID(id);
                scrollToBottom();
            } else {
                setMessageList([...newMessageList, ...messageList]);
                const height = messagesEnd.current.clientHeight;
                messagesEnd.current.scrollTop = height;
            }
        })
    }
    useEffect(() => {
        onMessage();
    }, [])
    useEffect(() => {
        let data = newMessage;
        if (userID == newMessage.sendID && userID) {
            let current = newMessage.sendTime;
            let minutes;
            let lastShowTime = messageList[messageList.length - 1].sendTime;
            minutes = (current - lastShowTime) / 1000 / 60;
            if (minutes > 5) {
                data = {
                    ...data,
                    showTime: true
                }
            } else {
                data = {
                    ...data,
                    showTime: false
                }
            }
            if ([102, 108].includes(data.contentType)) {
                data = {
                    ...data,
                    content: JSON.parse(data.content)
                }
            }
            setMessageList([...messageList, data]);
            readMessage(userID);
        }
    }, [newMessage]);
    const onMessage = () => {
        openIM.on(CbEvents.ONRECVNEWMESSAGE, (res) => {
            let data = JSON.parse(res.data);
            if (data.status == 2) {
                setNewMessage(data);
            }
        })
    }
    const scrollToBottom = () => {
        if (messagesEnd && messagesEnd.current) {
            const scrollHeight = messagesEnd.current.scrollHeight;
            const height = messagesEnd.current.clientHeight; //网页可见高度  200px
            const maxScrollTop = scrollHeight - height;
            messagesEnd.current.scrollTop = maxScrollTop > 0 ? maxScrollTop : 0;
        }
    };
    const [content, setContent] = useState('')

    // 默认textarea的最高行数
    const [defaultMaxRows] = useState(5)

    const [rows, setRows] = useState(1)

    const hiddenTextarea: any = useRef<HTMLDivElement>(null);
    const interContent: any = useRef<HTMLDivElement>(null);

    const maxRows = useMemo(() => props.maxRows || defaultMaxRows, [props.maxRows])

    useEffect(() => {
        return () => {
            let r = hiddenTextarea?.current?.scrollHeight / hiddenTextarea?.current?.clientHeight
            if (r > maxRows) r = maxRows
            setRows(r)
        }
    }, [maxRows, content])

    // 用户输入内容是否可以发送
    // 去除输入内容的收尾两端空格
    const disable = useMemo(() => content.replace(/(^\s+)|(\s+$)/g, '') === '', [content])

    // 发送消息
    const sendMessage = () => {
        openIM.createTextMessage(content).then(res => {
            const options = {
                recvID: userID,
                groupID: "",
                message: res.data,
            };
            openIM.sendMessage(options).then(({
                data,
            }) => {
                handleSendMessage(data);
                setContent("");
            })
        })
    }

    function onChange(e) {
        setContent(e.target.value)
    }

    function onFocus() {
        scrollToBottom();
    }
    const readMessage = (id) => {
        const options = {
            userID: id,
            msgIDList: []
        };
        openIM.markC2CMessageAsRead(options)
    }
    const [emojiShow, setemojiShow] = useState(true);
    const [strStart, setstrStart]: any = useState();
    const handleEmoji = () => {
        setemojiShow(!emojiShow);
        onFocus();
    };
    const emojiList = [ // emoji 数据列表
        { id: 1, emoji: '😀' },
        { id: 2, emoji: '😂' },
        { id: 3, emoji: '🥂' },
        { id: 4, emoji: '🤩' },
        { id: 5, emoji: '👿' },
        { id: 6, emoji: '😛' },
        { id: 7, emoji: '🤫' },
        { id: 8, emoji: '😑' },
        { id: 9, emoji: '🙄' },
        { id: 10, emoji: '🤐' },
        { id: 11, emoji: '🤑' },
        { id: 12, emoji: '🤗' },
        { id: 13, emoji: '😏' },
        { id: 14, emoji: '🥃' },
        { id: 15, emoji: '😒' },
        { id: 16, emoji: '😪' },
        { id: 17, emoji: '😴' },
        { id: 18, emoji: '🤤' },
        { id: 19, emoji: '🤧' },
        { id: 20, emoji: '🥶' }
    ]
    const onBlur = () => {
        const strStart = interContent.current.selectionStart;
        setstrStart(strStart);
    }
    const handleOk = emoji => {
        setstrStart(strStart + 2);
        setContent(insertStr(content, strStart, emoji));
        handleEmoji();
    }
    const insertStr = (soure, start, newStr) => {
        return soure.slice(0, start) + newStr + soure.slice(start)
    }
    const val = {
        name: 'file',
        action: "http://47.108.135.38:30002/api/v1/openim_upload",
        // action: "http://localhost:3000/api/v1/openim_upload",
        headers: {
            authorization: 'authorization-text',
        },
        multiple: true,
        showUploadList: false,
        onChange(info) {
            if (info.file.status === 'done') {
                creatImage(info.file)
            }
        },
    };
    const creatImage = (val) => {
        let { uid: uuid, type, size, response } = val;
        const baseInfo = {
            uuid, //图片唯一id
            type: type.split("/")[1], //图片类型
            size, //图片大小
            width: 1080, //图片宽度
            height: 720, //图片高度
            url: response.data
        }
        const data = {
            sourcePicture: baseInfo, //原图信息
            bigPicture: baseInfo, //大图信息
            snapshotPicture: baseInfo, //缩略图信息
        }
        openIM.createImageMessage(data).then(res => {
            const options = {
                recvID: userID,
                groupID: "",
                message: res.data,
            };
            openIM.sendMessageNotOss(options).then(({
                data,
            }) => {
                handleSendMessage(data);
            })
        })
    }
    const handleSendMessage = (data) => {
        let newMessage = JSON.parse(data);
        if (messageList.length > 0) {
            let {
                sendTime
            } = messageList[messageList.length - 1];
            let minutes = (newMessage.sendTime - sendTime) / 1000 / 60;
            if (minutes > 5) {
                newMessage = {
                    ...newMessage,
                    showTime: true
                };
            } else {
                newMessage = {
                    ...newMessage,
                    showTime: false
                };
            }
        } else {
            newMessage = {
                ...newMessage,
                showTime: true
            };
        }
        if (newMessage.contentType == 102) {
            newMessage = {
                ...newMessage,
                content: JSON.parse(newMessage.content)
            };
        }
        setMessageList([...messageList, newMessage]);
        scrollToBottom();
    }
    const getMoreMessage = () => {
        getHistoryMessage(true, userID)
    }
    const House_direction = {
        1: "东",
        2: "南",
        3: "西",
        4: "北"
    }
    const [face_url, setface_url] = useState("");
    const openim_id = sessionStorage.getItem('openim_id');
    const getopen_info = async () => {
        const { data } = await GetOpen_Info({ openim_id });
        const { face_url, gender } = data;
        if (face_url) {
            setface_url(face_url);
        } else {
            const { data: { pic } } = await GetMateral_info({ mtype: gender == 1 ? 3 : 4 });
            setface_url(pic);
        }
    }
    useEffect(() => {
        getopen_info();
    }, []);
    const [flag, setflag] = useState(true);
    const [offset, setoffset] = useState(10);
    const Scroll = () => {
        let height1 = myref.current.clientHeight;
        let height2 = myref.current.scrollTop;
        let height3 = myref.current.scrollHeight;
        if (height1 + height2 == height3 && flag) {
            getPageChat();
        }
    }
    const getPageChat = () => {
        const options = {
            offset,
            count: 10
        }
        openIM.getConversationListSplit(options).then(res => {
            const str = JSON.parse(res.data);
            if (str.length == 0) {
                setflag(false);
            } else {
                const val = str.map(item => {
                    return { ...item, latestMsg: JSON.parse(item.latestMsg) }
                })
                props.setIMList([...props.imList, ...val]);
                setoffset(offset + 10);
            }
        })
    }
    return (<>
        <Row>
            <Col span={6}>
                <div className="msg-Left-header">消息</div>
                <div className="leftSider" ref={myref} onScroll={Scroll}>
                    {props.imList.map((item, index) => {
                        return <Dropdown overlay={() =>
                            <Popconfirm
                                title="确认删除该聊天"
                                onConfirm={confirm}
                                okText="确定"
                                cancelText="取消"
                            >
                                <Menu>
                                    <Menu.Item key={item.conversationID}
                                        onClick={(e) => {
                                            setconversationID(e.key)
                                        }}
                                    >
                                        删除
                                    </Menu.Item>
                                </Menu>
                            </Popconfirm>
                        }
                            trigger={['contextMenu']} key={item.conversationID}>
                            <div className={`chatlist ${index == currentIndex ? "active" : ""}`} data-userid={item.userID}
                                onClick={(e) => {
                                    getHistoryMessage(false, e.currentTarget.getAttribute("data-userid"));
                                    setcurrentIndex(index)
                                }}>
                                <Badge count={item.unreadCount}>
                                    <Avatar shape="square" size="large" src={item.faceURL} icon={item.faceURL ? '' : <UserOutlined />} />
                                </Badge>
                                <div className="message">
                                    <div className="details">
                                        <h4>{item.showName}</h4>
                                        <span>{getDateDiff(now, item.latestMsgSendTime)}</span>
                                    </div>
                                    <div className="chatRight">
                                        <span>{item.latestMsg.contentType === 101 ? item.latestMsg.content : `[图片]`}</span>
                                    </div>
                                </div>
                            </div>
                        </Dropdown>
                    })}
                </div>
            </Col>
            <Col span={17} offset={1}>
                {messageList.length > 0 ?
                    <div className="rightSide">
                        <h1 className="showName">{props.imList[currentIndex].showName}</h1>
                        <Divider />
                        <div className="msgList" ref={messagesEnd}>
                            <div className="showName more" onClick={getMoreMessage} hidden={hasMore}>查看更多消息</div>
                            {messageList.map(item => {
                                if (item.sendID === userID) {
                                    if (item.contentType == 101) {
                                        return <div key={item.clientMsgID}>
                                            <div className="showTime">{item.showTime ? getDateDiff(now, item.sendTime) : ""}</div>
                                            <div className="sendMessage">
                                                <Avatar shape="square" size="large" src={item.senderFaceUrl} />
                                                <span className="contentText">{item.content}</span>
                                            </div>
                                        </div>
                                    } else if (item.contentType == 102) {
                                        return <div key={item.clientMsgID}>
                                            <div className="showTime">{item.showTime ? getDateDiff(now, item.sendTime) : ""}</div>
                                            <div className="sendMessage">
                                                <Avatar shape="square" size="large" src={item.senderFaceUrl} />
                                                <Image className="contentImage" src={item.content.sourcePicture.url} />
                                            </div>
                                        </div>
                                    } else {
                                        return <div key={item.clientMsgID}>
                                            <div className="showTime">{item.showTime ? getDateDiff(now, item.sendTime) : ""}</div>
                                            <div className="sendMessage">
                                                <Avatar shape="square" size="large" src={item.senderFaceUrl} />
                                                {item.content.data.map((key, index) => {
                                                    return <Link key={index} to={{ pathname: "/admin/house/manager/details", state: key }}>
                                                        <div className="cardMsg">
                                                            <img className="house_pic" src={key.house_pic[0]} />
                                                            <div className="cardText">
                                                                <span className="garden_name">{key.garden_name}</span>
                                                                <span className="house_room">{key.room_count}室{key.hall_count}厅 /{key.room_area}m² /{House_direction[key.direction]}</span>
                                                                <span className="house_price">{key.rent_price}元</span>
                                                            </div>
                                                        </div>
                                                    </Link>
                                                })}
                                            </div>
                                        </div>
                                    }
                                } else {
                                    if (item.contentType == 101) {
                                        return <div key={item.clientMsgID}>
                                            <div className="showTime">{item.showTime ? getDateDiff(now, item.sendTime) : ""}</div>
                                            <div className="mysendMessage">
                                                <Avatar shape="square" size="large" src={face_url} />
                                                <span className="contentText mycontentText">{item.content}</span>
                                            </div>
                                        </div>
                                    } else if (item.contentType == 102) {
                                        return <div key={item.clientMsgID}>
                                            <div className="showTime">{item.showTime ? getDateDiff(now, item.sendTime) : ""}</div>
                                            <div className="mysendMessage">
                                                <Avatar shape="square" size="large" src={face_url} />
                                                <Image className="contentImage" style={{ marginLeft: 0, marginRight: "20px" }} src={item.content.sourcePicture.url} />
                                            </div>
                                        </div>
                                    } else {
                                        <div key={item.clientMsgID}>
                                            <div className="showTime">{item.showTime ? getDateDiff(now, item.sendTime) : ""}</div>
                                            <div className="mysendMessage">
                                                <Avatar shape="square" size="large" src={face_url} />
                                                <span>卡片消息</span>
                                            </div>
                                        </div>
                                    }
                                }
                            })}
                        </div>
                        <div className="addOther">
                            <SmileOutlined className="iconSize" onClick={handleEmoji} />
                            <Upload {...val}>
                                <PictureOutlined onClick={onFocus} className="iconSize" />
                            </Upload>
                            <div className="incoList" hidden={emojiShow}>
                                {emojiList.map(item => {
                                    return <span key={item.id} onClick={() => handleOk(item.emoji)} >{item.emoji}</span>
                                })}
                            </div>
                        </div>
                        <div className="m-input-area__wrapper">
                            <div className="m-input-area__content">
                                <textarea
                                    spellCheck={false}
                                    placeholder="输入聊天内容..."
                                    rows={rows}
                                    value={content}
                                    onChange={onChange}
                                    onFocus={onFocus}
                                    onBlur={onBlur}
                                    ref={interContent}
                                />

                                {/* 不可见的输入框 */}
                                <textarea readOnly rows={1} value={content} ref={hiddenTextarea} />
                            </div>
                            <input
                                className={`m-input-area__btn ${disable ? 'disable' : ''}`}
                                type="button"
                                value="发送"
                                disabled={disable}
                                onClick={sendMessage}
                            />
                        </div>
                    </div> : <></>
                }
            </Col>
        </Row>
    </>)
}

const mapStateToProps = (state) => {
    return {
        imList: state.getIMList.list
    }
}
const mapDispatchToProps = (dispatch) => {
    return {
        setIMList: (userInput) => dispatch(setIMlist(userInput)),
    }
}

export default connect(mapStateToProps, mapDispatchToProps)(CustomerService)