import React, { useEffect, useState } from "react";
import { useHistory } from "react-router";
import { Button, Card, Table } from "antd";
import ProTable from "@ant-design/pro-table";
import { CommandList } from "../../services/device";
import type { ActionType } from "@ant-design/pro-table";
import { getLocalTime } from "../../utils/utils";

const Command = (props) => {
    const history = useHistory();
    const device_id = history.location.search.split('?')[1];
    const actionRef: any = React.useRef<ActionType>();
    const columns: any = [
        {
            title: "状态",
            dataIndex: "status",
            align: "center",
            render: (_, row) => <>
                {row.status == 1 ? <span>待执行</span> : null}
                {row.status == 2 ? <span>执行中</span> : null}
                {row.status == 3 ? <span>执行完成</span> : null}
            </>
        },
        {
            title: "操作时间",
            align: "center",
            dataIndex: "created_at",
            render: (_, row) => <span>
                {getLocalTime(row.created_at)}
            </span>
        },
        {
            title: "操作详情",
            align: "center",
            dataIndex: "desc"
        }
    ]

    return <>
        <Card title="操作记录详情" extra={<Button type="primary" onClick={history.goBack}>返回</Button>}>
            <ProTable
                toolbar={{
                    actions: [
                        <Button
                            key="key"
                            type="primary"
                            onClick={history.goBack}
                        >
                            返回
                        </Button>
                    ],
                }}
                search={false}
                bordered
                actionRef={actionRef}
                rowKey="id"
                request={CommandList}
                params={{ device_id }}
                columns={columns}
            />
        </Card>
    </>
}

export default Command