import React, { useEffect, useState } from "react";
import { useHistory } from "react-router";
import { GateUnit } from "../../services/device";
import { Button, Card, Tree, message } from 'antd';


const DoorPermission = () => {
    const hisitory = useHistory();
    const location = hisitory.location;
    const { device_id }: any = location.state;
    const [treeData, settreeData]: any = useState([]);
    const [expandedKeys, setExpandedKeys]: any = useState([]);
    const [checkedKeys, setCheckedKeys]: any = useState([]);
    const [selectedKeys, setSelectedKeys]: any = useState([]);
    const [autoExpandParent, setAutoExpandParent] = useState(true);
    const [value,setValue] = useState([]);
    const onExpand = (expandedKeysValue) => {
        setExpandedKeys(expandedKeysValue);
        setAutoExpandParent(false);
    };
    const onSelect = (selectedKeys, info) => {
        setSelectedKeys(selectedKeys);
    };
    const onCheck = (checkedKeys, info) => {
        setCheckedKeys(checkedKeys);
    };
    useEffect(() => {
        getUnit()
    }, [])
    const getUnit = async () => {
        const { data } = await GateUnit({ device_id });
        let CheckedKeys: any = [];
        let expandedKeys: any = [];
        const result = data.map((item, index) => {
            let units: any = [];
            if (item.units.length > 0) {
                item.units.map(key => {
                    units.push({ ...key, building_name: key.unit_name });
                    if (key.selected) {
                        CheckedKeys.push(key.unit_id);
                        expandedKeys.push(item.building_name)
                    }
                })
            }
            return { ...item, unit_id: item.building_name, units }
        })
        const treeData = [
            {
                building_name: "全部",
                unit_id: "all",
                units: result
            }
        ]
        settreeData(treeData);
        setCheckedKeys(CheckedKeys);
        setExpandedKeys(expandedKeys);
        setValue(CheckedKeys);
    }
    const submit = async () => {
        let unit_id = checkedKeys.filter(item => !isNaN(item));
        if (unit_id.toString()  !== value.toString() ) {
            await GateUnit({ method: "post", device_id, unit_id });
            message.success("操作成功！");
        }
    }

    return (<>
        <Card
            title="注：如果没有添加权限范围则小区所有人不可通行，添加后只对列表中单元业主可通行，权限访问单位为单元"
            extra={<Button type="primary" onClick={hisitory.goBack}>返回</Button>}
        >
            <Tree
                checkable
                onExpand={onExpand}
                expandedKeys={expandedKeys}
                autoExpandParent={autoExpandParent}
                checkedKeys={checkedKeys}
                selectedKeys={selectedKeys}
                onSelect={onSelect}
                onCheck={onCheck}
                fieldNames={{ title: "building_name", key: "unit_id", children: "units" }}
                treeData={treeData}
            />
            <div style={{ display: "flex", justifyContent: "center", margin: "20px 0" }}>
                <Button type="primary" onClick={submit}>保存</Button>
            </div>
        </Card>
    </>)
}

export default DoorPermission