import { MailOutlined, SettingOutlined } from '@ant-design/icons';
import { Menu, Switch } from 'antd';
import { useState } from 'react';
import "./index.scss"

function getItem(label, key,  children:any) {
  return {
    key,
    children,
    label,
  };
}

const items = [
  getItem('更多', 'sub1', [
    getItem('开门记录', '1',null),
    getItem('访客留影', '2',null),
    getItem('远程开门', '3',null),
    getItem('重启', '4',null),
    getItem('数据同步', '5',null),
    getItem('操作记录', '6',null), 
  ]),
];

const App = () => {
  const [theme, setTheme] :any= useState('dark');
  const [current, setCurrent] = useState('');

  const changeTheme = (value) => {
    setTheme(value ? 'dark' : 'light');
  };

  const onClick = (e) => {
    console.log('click ', e);
    setCurrent(e.key);
  };

  return (
    <>
      <Menu
        theme="light"
        onClick={onClick}
        style={{paddingLeft:0}}
        mode="inline"
        className='moreOption'
        items={items}
      />
    </>
  );
};

export default App;