import React from "react";
import { useHistory } from "react-router";
import { getLocalTime } from "../../utils/utils";
import { Button } from "antd";
import type { ActionType } from "@ant-design/pro-table";
import ProTable from "@ant-design/pro-table";
import { Record } from "../../services/device";

const VisitroRecord = () => {
    const history = useHistory();
    const result = history.location.search.split('?')[1].split('&');
    const device_id = result[0].split('=')[1];
    const actionRef: any = React.useRef<ActionType>();

    const columns:any = [
        {
            title:"邀请人",
            align:"center",
            dataIndex:"household_user",
        },
        {
            title:"被邀请人",
            align:"center",
            dataIndex:"visitor_name",
        },
        {
            title:"被邀请人联系方式",
            align:"center",
            dataIndex:"visitor_phone",
        },
        {
            title:"开门时间",
            align:"center",
            dataIndex:"open_time",
            render: (_, row) => getLocalTime(row.open_time)
        },
    ]
    return (<>
        <ProTable
            toolbar={{
                actions: [
                    <Button
                        key="key"
                        type="primary"
                        onClick={history.goBack}
                    >
                        返回
                    </Button>
                ],
            }}
            search={false}
            actionRef={actionRef}
            rowKey="open_time"
            request={Record}
            params={{ device_id ,is_visitor:1}}
            columns={columns}
        />
    </>)
}

export default VisitroRecord