import HouseDetails from './lease-create'
import React from 'react';
import { Steps, Button, message, Radio, Form, Input, Card } from 'antd';
import { useState } from 'react';
import { useHistory } from 'react-router';
import Broker from './assigning-broker';
import { RentHouseApprove } from '../../services/rent';

const HouseCheck = (props) => {
    const history = useHistory();
    const location = history.location
    const state: any = location.state
    const [current, setCurrent] = useState(0);
    const [value, setValue] = useState(true);
    const [form] = Form.useForm()
    const { Step } = Steps;
    const [status, setStatus] = useState(true)
    const [formInfo, setFormInfo]: any = useState()
    const onChange = e => {
        setValue(e.target.value);
    };
    const check = <>
        <Form
            form={form}
            // labelCol={{span:5}}
            wrapperCol={{ span: 5 }}
        >
            <Form.Item label="是否通过审核" name="status" rules={[{ required: true, message: "请选择审核状态" }]}>
                <Radio.Group onChange={onChange} value={value} >
                    <Radio value={true}>通过</Radio>
                    <Radio value={false}>不通过</Radio>
                </Radio.Group>
            </Form.Item>
            <Form.Item label="审核意见" name="feedback">
                <Input.TextArea placeholder='请输入审核意见' />
            </Form.Item>
        </Form>
    </>

   
    const next = () => {
        setCurrent(current + 1);
    };
    const prev = () => {
        setCurrent(current - 1);
    };
    const approve = () => {
        form.validateFields().then(async (value) => {
            console.log(value);
            const { status } = value;
            setStatus(status)
            await next()
            setFormInfo(value)
        })
    }
    const successApprove = async () => {
         await RentHouseApprove({ ...formInfo, id: state.id })
        message.success('操作成功')
        history.goBack()
    }
    const steps = [
        {
            title: '完善基本信息',
            content: <HouseDetails />,
        },
        {
            title: '审核',
            content: check,
        },
        {
            title: status ? '分配经纪人' : "未通过",
            content: status ? <Broker rent_id={state.id} /> : <>
                <Card extra={<>
                    <Button type='primary' onClick={successApprove} style={{marginRight:'20px'}}>保存</Button>
                    <Button type='primary' onClick={history.goBack}>返回</Button>
                </>} />
            </>,
        },
    ];
    return (<>
        <Steps current={current} style={{ marginBottom: '20px' }}>
            {steps.map(item => (
                <Step key={item.title} title={item.title} />
            ))}
        </Steps>
        {steps[current].content}
        <div className="steps-action">
            {current === 0 && (
                <Button type="primary" onClick={() => next()}>
                    下一步
                </Button>
            )}
            {current === 1 && (
                <Button type="primary" onClick={approve}>
                    保存下一步
                </Button>
            )}
            {current === steps.length - 1 && status && (
                <Button type="primary" onClick={successApprove}>
                    保存
                </Button>
            )}
            {current > 0 && (
                <Button style={{ margin: '0 8px' }} onClick={() => prev()}>
                    上一步
                </Button>
            )}
        </div>

    </>)
}

export default HouseCheck