import React, { useEffect, useState } from "react";
import { Msg_packageList, OrderMsg_package } from "../../services/application";
import { Button } from "antd";
import { Link } from "react-router-dom";
import "./msg_package.scss"

const Msg_package = (props) => {
    const [data, setData]: any = useState([]);
    useEffect(() => {
        getData();
    }, []);
    const getData = async () => {
        const { data } = await Msg_packageList({ page: -1, page_size: -1, })
        setData(data)
    }
    return (<>
        {data.length == 0 ? <div>
            <img src="https://gimg2.baidu.com/image_search/src=http%3A%2F%2Fimg.58cdn.com.cn%2Fdist%2Fjxedt%2Fpc%2Fproducts%2Fjxregister%2Fimages%2Fno_data.png&refer=http%3A%2F%2Fimg.58cdn.com.cn&app=2002&size=f9999,10000&q=a80&n=0&g=0n&fmt=auto?sec=1671259580&t=8afe5b7451ccd0c4e57be61ef0cf278b" />
        </div> :
            <div className="application_main">
                {data.map((item, index) => {
                    return <div key={item.id} className="application_content">
                        <div>套餐名：{item.name}</div>
                        <div>短信条数：{item.msg_count}条</div>
                        <div>价格：{item.price / 100}元</div>
                        <div className="application_desc_content" title={item.comment}>套餐描述：{item.comment}</div>
                        <div className="bottom_content">
                            <Link to={{ pathname: "/admin/msg/msg_package/buy", state: item }}>
                                <Button type="primary">购买</Button>
                            </Link>

                        </div>
                    </div>
                })}
            </div>
        }
    </>)
}

export default Msg_package