import React from "react";
import type { ActionType } from "@ant-design/pro-table";
import ProTable from "@ant-design/pro-table";
import { OrderMsg_package } from "../../services/application";
import { Link } from "react-router-dom";
import { Button } from "antd";

const OwnerMsg = () =>{
    const actionRef: any = React.useRef<ActionType>();
    const columns: any = [
        {
            title: "小区名",
            align: "center",
            search: false,
            dataIndex: "garden_name"
        },
        {
            title: "套餐名",
            align: "center",
            search: false,
            dataIndex: "name"
        },
        {
            title: "短信总数",
            align: "center",
            search: false,
            dataIndex: "msg_total_count",
        },
        {
            title: "剩余短信数",
            align: "center",
            dataIndex: "msg_available_count",
        },
        {
            title: "操作",
            align: "center",
            search: false,
            dataIndex: "option",
            render: (_, row) => <Link to={{pathname:"/admin/msg/owner/detail",state:row}}>
                <Button type="link">详情</Button>
            </Link>
        }
    ]
    return(<>
     <ProTable
            actionRef={actionRef}
            rowKey="order_id"
            search={false}
            options={false}
            request={OrderMsg_package}
            params={{status:2}}
            columns={columns}
        />
    </>)
}

export default OwnerMsg