import React, { useEffect } from "react";
import { useHistory } from "react-router";
import { Button, Card, Form } from "antd";
import { connect } from "react-redux";
import { getOwnerCar } from "../../redux/action/owner";
import './index.scss'

const CarInfo = (props) => {
    const history = useHistory();
    const location = history.location
    const household_uid: any = location.state
    useEffect(() => {
         props.getOwnerCar({ household_uid })
    }, [])
    
    return <>
        <Card extra={<Button type="primary" onClick={history.goBack}>返回</Button>}>
            {props.car_info.getCarInfo.list.map(item => {
                return <Card type="inner" title={`${item.plate_no}  车辆信息`} key={item.id} style={{ marginBottom: '10px' }}>
                    <Form
                        layout='inline'
                        className="house_infoList"
                    >
                        <Form.Item label="车辆品牌">
                        {<span>{item.brand}</span>}
                        </Form.Item>
                        <Form.Item label="车身颜色">
                        {<span>{item.color}</span>}
                        </Form.Item>
                    </Form>
                </Card>
            })}
        </Card>
    </>
}
const mapStateToProps = (state) => {
    return {
        car_info: state,
    }
}

const mapDispatchToProps = (dispatch) => {
    return {
        getOwnerCar: (userInput) => dispatch(getOwnerCar(userInput)),
    }
}

export default connect(mapStateToProps, mapDispatchToProps)(CarInfo)