import React, { useEffect, useState } from "react";
import { useHistory } from "react-router";
import { Button, Card, Form } from "antd";
import { connect } from "react-redux";
import { SELECTOR_HOUSE_TYPE2 } from "../../CONSTANT";
import { getHouseBuildingsList } from "../../redux/action/owner";
import './index.scss'

const HouseInfo = (props) => {
    const history = useHistory();
    const location = history.location
    const household_uid: any = location.state
    useEffect(() => {
        props.getHouseBuildingsList({ household_uid })
    }, [])

    return <>
        <Card extra={<Button type="primary" onClick={history.goBack}>返回</Button>}>
            {props.house_info.getBuilindsHouse.list.map(item => {
                return <Card type="inner" title={`${item.house_name}房屋信息`} key={item.id} style={{ marginBottom: '10px' }}>
                    <Form
                        layout='inline'
                        className="house_infoList"
                    >
                        <Form.Item label="楼栋">
                        {<span>{`${item.building_number}栋`}</span>}
                        </Form.Item>
                        <Form.Item label="单元">
                        {<span>{`${item.unit_number}单元`}</span>}
                        </Form.Item>
                        <Form.Item label="楼层">
                            {<span>{`${item.layer}层`}</span>}
                        </Form.Item>
                        <Form.Item label="建筑面积">
                        {<span>{`${item.house_area}m²`}</span>}
                        </Form.Item>
                        <Form.Item label="使用面积">
                        {<span>{`${item.house_used_area}m²`}</span>}
                        </Form.Item>
                        <Form.Item label="类型">
                            {<span>{SELECTOR_HOUSE_TYPE2[item.house_type]}</span>}
                        </Form.Item>
                        <Form.Item label="户型">
                            {<span>{`${item.room_count}室${item.hall_count}厅`}</span>}
                        </Form.Item>
                    </Form>
                </Card>
            })}
        </Card>
    </>
}
const mapStateToProps = (state) => {
    return {
        house_info: state,
    }
}

const mapDispatchToProps = (dispatch) => {
    return {
        getHouseBuildingsList: (userInput) => dispatch(getHouseBuildingsList(userInput)),
    }
}

export default connect(mapStateToProps, mapDispatchToProps)(HouseInfo)