import React from 'react'
import type { ActionType } from '@ant-design/pro-table'
import ProTable from '@ant-design/pro-table'
import { Button, Modal, message, Image } from 'antd'
import { withRouter } from 'react-router-dom'
import { Link } from 'react-router-dom'
import '../index.scss'
import { Notice } from '../../../services/service/notice'


const Neighbor: React.FC = (props: any) => {
  // @ts-ignore
  const columns: any = [
    {
      title: '标题',
      dataIndex: 'title'
    },
    {
      title: '操作',
      dataIndex: 'option',
      search: false,
      width: 210,
      align: 'center',
      render: (_, row, index, action) => <>
       <Link to={{ pathname: "/admin/service/notice/detailnotice", state: row }}>
          <Button type='link'>详情</Button>
        </Link>
        <Link to={{ pathname: "/admin/service/notice/editnotice", state: row }}>
          <Button type='link'>修改</Button>
        </Link>
        <Button type='link' onClick={() => deleteNotice(row.id)}>删除</Button>
      </>
    }
  ]
  const [state, setState] = React.useState({
    visible: false,
  })
  const deleteNotice = (id) => {
    Modal.confirm({
      title: "删除公告",
      content: "你确定删除这条记录吗？",
      onOk: async () => {
        await Notice({ method: "delete", id });
        message.success("操作成功！");
        actionRef.current?.reload()
      }
    });
  }

  const actionRef = React.useRef<ActionType>();
  return (
    <React.Fragment>
      <ProTable
        actionRef={actionRef}
        search={false}
        rowKey={r=>r.id}
        request={Notice}
        toolBarRender={() => [
          <Link to="/admin/service/notice/addnotice">
            <Button type='primary'>发布</Button>
          </Link>
        ]}
        columns={columns}
      />
    </React.Fragment>
  )
}

export default withRouter(Neighbor)