import React from 'react'
import type { ActionType } from '@ant-design/pro-table'
import ProTable from '@ant-design/pro-table'
import { Button ,Modal,message} from 'antd'
import { withRouter } from 'react-router-dom'
import { Event } from '../../../services/service/event'
import { Link } from 'react-router-dom'
import '../index.scss'

const Activity: React.FC = (props: any) => {
  // @ts-ignore
  const columns: any = [
    {
      title: '标题',
      dataIndex: 'title'
    },
    {
      title: '发布时间',
      dataIndex: 'created_at'
    },
    {
      title: '总名额',
      dataIndex: 'people_limit',
      search: false,
    },
    {
      title: '剩余名额',
      dataIndex: 'people_count',
      search: false,
      render: (_, row) => <span>{row.people_limit - row.people_count}</span>
    },
    {
      title: '操作',
      dataIndex: 'option',
      search: false,
      // width: 210,
      align: 'center',
      render: (_, row, index, action) => <>
        <Link to={{ pathname: "/admin/service/notice/detailevent",state:row }}>
            <Button type='link'>详情</Button>
          </Link>
        <Link to={{ pathname: "/admin/service/notice/editevent",state:row }}>
            <Button type='link'>修改</Button>
          </Link>
        <Button type='link' onClick={()=>deleteEvent(row.id)}>删除</Button>
        <Link to={{ pathname: "/admin/service/notice/sign",state:row.id }}>
            <Button type='link'>报名列表</Button>
          </Link>
      </>
    }
  ]
  const deleteEvent = (id) =>{
    Modal.confirm({
      title: "删除活动",
      content: "你确定删除这条活动记录吗？",
      onOk: async () => {
        await Event({ method: "delete", id });
        message.success("操作成功！");
        actionRef.current?.reload()
      }
    });
  }
  const actionRef = React.useRef<ActionType>();
  return (
    <React.Fragment>
      <ProTable
        actionRef={actionRef}
        rowKey="id"
        request={Event}
        search={false}
        toolBarRender={() => [
          <Link to={{ pathname: "/admin/service/activity/addevent" }}>
            <Button type='primary'>添加小区活动</Button>
          </Link>
        ]}
        columns={columns}
      />
    </React.Fragment>
  )
}

export default withRouter(Activity)