import { Button, Card, Form, Image, Input } from "antd";
import React from "react";
import { useHistory } from "react-router";
import { getLocalTime } from "../../../utils/utils";

const DetailEvent = (props) => {
    const history = useHistory();
    const location = history.location
    const { state }: any = location
    return <>
        <Card
            title={`${state.title}详情`}
            extra={<Button type="primary" onClick={history.goBack}>返回</Button>}
        >
            <Form
                labelCol={{ span: 3 }}
                labelAlign="left"
            >
                <Form.Item label="活动标题">
                    {state.title}
                </Form.Item>
                <Form.Item label="活动内容">
                    <div className="detailNotice"
                        dangerouslySetInnerHTML={{ __html: state.content }}
                    ></div>
                </Form.Item>
                <Form.Item label="图片">
                    {state.pic.map(item => {
                        if (item == '') {
                            return null
                        } else {
                            return <Image src={item} key={item} style={{height:'200px',width:'200px'}}/>
                        }
                    })}
                </Form.Item>
                <Form.Item label="活动时间">
                    {`${getLocalTime(state.start)}--${getLocalTime(state.end)}`}
                </Form.Item>
                <Form.Item label="报名结束时间">
                    {getLocalTime(state.sign_up_end)}
                </Form.Item>
                <Form.Item label="人数限制">
                    {state.people_limit}
                </Form.Item>
                <Form.Item label="报名费用">
                    {state.fee/100}
                </Form.Item>
                <Form.Item label="活动地址">
                    {state.addr}
                </Form.Item>
            </Form>
        </Card>
    </>
}

export default DetailEvent