import React from "react";
import { useHistory } from "react-router";
import ProTable from "@ant-design/pro-table";
import type { ActionType } from '@ant-design/pro-table'
import { Button ,Modal,message} from "antd";
import { Sign } from "../../../services/service/event";

const EventSign = () => {
    const hisitory = useHistory();
    const location = hisitory.location;
    const event_id = location.state;
    const actionRef = React.useRef<ActionType>();
    const columns :any = [
        {
            title:"姓名",
            dataIndex:"name"
        },
        {
            title:"手机号",
            dataIndex:"phone"
        },
        {
            title:"报名人数",
            dataIndex:"count"
        },
        {
            title:"报名时间",
            dataIndex:"sign_time"
        },
        {
            title:"备注",
            dataIndex:"comment"
        },
        {
            title:"操作",
            dataIndex:"option",
            render:(_,row)=><Button type="link" onClick={()=>deleteSign(row.id)}>删除</Button>
        }
    ]
    const deleteSign =(id) =>{
        Modal.confirm({
            title: "删除报名记录",
            content: "你确定删除这条报名记录吗？",
            onOk: async () => {
              await Sign({ method: "delete", id });
              message.success("操作成功！");
              actionRef.current?.reload()
            }
          });
    }

    return <>
        <ProTable
            actionRef={actionRef}
            rowKey="id"
            request={Sign}
            params={{event_id}}
            search={false}
            toolBarRender={() => [
                <Button type="primary" onClick={hisitory.goBack} >返回</Button>
            ]}
            columns={columns}
        />
    </>
}
export default EventSign