import { Button, Card, Form, Image } from "antd";
import React from "react";
import { useHistory } from "react-router";

const ArticleDetail = () => {
    const history = useHistory();
    const location = history.location
    const state: any = location.state
    const formInfo = [
        { label: "用户名", name: "user_name" },
        { label: "用户手机号", name: "user_phone" },
        { label: "用户头像", name: "user_icon" },
        { label: "文章标题", name: "title" },
        { label: "文章内容", name: "content" },
        { label: "文章图片", name: "pics" },
        { label: "文章点赞数", name: "likes" },
        { label: "评论总数", name: "comment_count" },
        { label: "是否本人发布", name: "owner" },
        { label: "点赞", name: "like" },
        { label: "创建时间", name: "created_at" },
        { label: "更新时间", name: "updated_at" }
    ]
    return <>
        <Card
            title={`${state.title}详情`}
            extra={<Button type="primary" onClick={history.goBack}>返回</Button>}
        >
            <Form labelCol={{span:3}} wrapperCol={{ span: 10 }} labelAlign="left">
                {formInfo.map(item => {
                    if (item.name == "user_icon") {
                        return <Form.Item label={item.label} key={item.label}>
                            <Image src={state[item.name]} style={{ width: "100px", height: '100px' }} />
                        </Form.Item>
                    } else if (item.name == "pics") {
                        return <Form.Item label={item.label} key={item.label}>
                            {state[item.name].map(key => {
                                return <Image src={key} style={{ width: "100px", height: '100px' }} />
                            })}
                        </Form.Item>
                    } else if (item.name == "owner") {
                        return <Form.Item label={item.label} key={item.label}>
                            {state[item.name] ? "本人发布" : "非本人发布"}
                        </Form.Item>
                    } else if (item.name == "like") {
                        return <Form.Item label={item.label} key={item.label}>
                            {state[item.name] ? "本人已点赞" : "本人未点赞"}
                        </Form.Item>
                    }
                    else {
                        return <Form.Item label={item.label} key={item.label}>
                            {state[item.name]}
                        </Form.Item>
                    }
                })}
            </Form>
        </Card>
    </>
}

export default ArticleDetail