import React, { useState } from 'react'
import type { ActionType } from '@ant-design/pro-table'
import ProTable from '@ant-design/pro-table'
import { Button, Modal, Form, Image, Card, message } from 'antd'
import { withRouter } from 'react-router-dom'
import { useHistory } from 'react-router'
import { NeighborComment } from '../../../services/service/neighbor'
import '../index.scss'

const Neighbor: React.FC = (props: any) => {
  const history = useHistory();
    const location = history.location
    const article_id: any = location.state
    const [comment_id,setcomment_id]=useState()
  // @ts-ignore
  const columns: any = [
    {
      title: '用户昵称',
      dataIndex: 'user_name'
    },
    {
      title: '评论内容',
      dataIndex: 'content'
    },
    {
      title: '子评论数',
      dataIndex: 'sub_comment_count'
    },
    {
      title: '评论时间',
      dataIndex: 'updated_at',
      search: false,
    },
    {
      title: '操作',
      dataIndex: 'option',
      search: false,
      width: 210,
      align: 'center',
      render: (_, row, index, action) => <>
       {row.sub_comment_count>0? <Button type='link' onClick={()=>{
          setcomment_id(row.id)
        }}>查看评论</Button>:<Button type='link' disabled>查看评论</Button>}
        <Button type='link' onClick={()=>deleteComment(row.id)}>删除</Button>
      </>
    }
  ]
  const deleteComment = (id) =>{
    Modal.confirm({
      title: "删除评论",
      content: "你确定删除这条记录吗？",
      onOk: async () => {
        await NeighborComment({ method: "delete", id });
        message.success("操作成功！");
        actionRef.current?.reload()
      }
    });
  }

  const actionRef = React.useRef<ActionType>();
  return (
    <React.Fragment>
      <ProTable
        actionRef={actionRef}
        rowKey="id"
        search={false}
        request={NeighborComment}
        params={{article_id,comment_id}}
        columns={columns}
        toolBarRender={() => [
          <Button type='primary' onClick={history.goBack}>返回</Button>
        ]}
      />
    </React.Fragment>
  )
}

export default withRouter(Neighbor)