import React from 'react'
import type { ActionType } from '@ant-design/pro-table'
import ProTable from '@ant-design/pro-table'
import { Button, Modal, Form, Image, Card, message } from 'antd'
import { Link, withRouter } from 'react-router-dom'
import { NeighborArticle } from '../../../services/service/neighbor'
import { useHistory } from 'react-router'
import '../index.scss'

const Neighbor: React.FC = (props: any) => {
  const history = useHistory();
  const location = history.location
  const class_id: any = location.state
  // @ts-ignore
  const columns: any = [
    {
      title: '文章标题',
      dataIndex: 'title',
    },
    {
      title: '住户信息',
      dataIndex: 'user_name',
      search: false
    },
    {
      title: '点赞数',
      dataIndex: 'likes',
      search: false,
    },
    {
      title: '评论数',
      dataIndex: 'comment_count',
      search: false,
    },
    {
      title: '更新时间',
      dataIndex: 'updated_at',
      search: false,
    },
    {
      title: '操作',
      dataIndex: 'option',
      search: false,
      width: 210,
      align: 'center',
      render: (_, row, index, action) => <>
        <Link to={{ pathname: "/admin/service/neighbor/page-list/detail", state: row }}>
          <Button type='link'>详情</Button>
        </Link>
        <Link to={{pathname:"/admin/service/neighbor/comments",state:row.id}}>
          <Button type='link'>查看评论</Button>
        </Link>
        <Button type='link' onClick={() => deleteArticle(row.id)}>删除</Button>
      </>
    }
  ]
  const deleteArticle = (id) => {
    Modal.confirm({
      title: "删除文章",
      content: "你确定删除这条记录吗？",
      onOk: async () => {
        await NeighborArticle({ method: "delete", id });
        message.success("操作成功！");
        actionRef.current?.reload()
      }
    });
  }

  const actionRef = React.useRef<ActionType>();
  return (
    <React.Fragment>
      <ProTable
        actionRef={actionRef}
        rowKey="id"
        search={{
          collapsed: false, collapseRender: () => false,
          span: 6
        }}
        request={NeighborArticle}
        params={{ class_id }}
        columns={columns}
        toolBarRender={() => [
          <Button type='primary' onClick={() => props.history.goBack()}>返回</Button>
        ]}
      />
    </React.Fragment>
  )
}

export default withRouter(Neighbor)