import { Card, Button, Form, Input, Switch, Rate, Divider, Radio, DatePicker, message, Select, } from "antd";
import { MinusCircleOutlined } from '@ant-design/icons';
import React, { useEffect, useState } from "react";
import history from "../../../utils/hisitory";
import Uploadpic from "../../../utils/handlePreview";
import moment from 'moment';
import { transitionSecond } from "../../../utils/utils";
import { Vote } from "../../../services/service/vote";
import "./vote.scss"

const AddVote = (props) => {
    const [pic, setPic]: any = React.useState([])
    const [form] = Form.useForm();
    const { state } = props;
    const [topic_number, setTopic_number]: any = useState([])


    const garden_pic = (arr) => {
        form.setFieldsValue({ pics: arr })
    }
    const addVote = () => {
        form.validateFields().then(async (values) => {
            const start = transitionSecond(values.start)
            const end = transitionSecond(values.end)
            let topics: any = [];
            let choiceAnswer: any = [];
            console.log(topic_number);
            
            if (values.topics && values.topics.length > 0) {
                topics = values.topics.map((item, index) => {
                    if ([2, 3].includes(item.topic_type)) {
                        let choices = [];
                        if (item.choice_items && item.choice_items.length > 0) {
                            choices = item.choice_items.map((key, num) => {
                                return { ...key, flag: String.fromCharCode(num + 65) }
                            })
                        } else {
                            choiceAnswer.push(false)
                        }
                        return { ...item, choice_items: choices, number: index + 1 }
                    } else {
                        return { ...item, number: index + 1 }
                    }
                })
                let topics2 = topics.map((item, index) => {
                    let topic_type
                    topic_number.map((key, num) => {
                        if (index == num) {
                            topic_type = key.type
                        }
                    })
                    return { ...item, topic_type }
                })
                if (!choiceAnswer.includes(false)) {
                    await Vote({
                        method: state ? "put" : "post",
                        ...values,
                        start,
                        end,
                        topics: topics2,
                        id: state ? state.id : ""
                    })
                    message.success("操作成功")
                    history.goBack()
                } else {
                    message.info("请为选择题至少添加一个选项")
                }
            } else {
                message.info("请添加至少一个题目类型")
            }
        })
    }
    const disabledDateStart = (current) => {
        return current < moment().subtract(1, 'day');
    }
    const disabledDateEnd = (current) => {
        return current && current < moment().endOf('day');
    }
    function deleteAndReset(arr, deleteIndex, howMany = 1) {
        if (!arr || arr.length == 0) {
            return []
        }
        let temp = arr.slice()
        temp.splice(deleteIndex, howMany)
        let front = temp.slice(0, deleteIndex)
        let end = temp.slice(deleteIndex)
        if (end.length > 0) {
            return front.concat(end.map(v => {
                return { number: v.number - 1, type: v.type }
            }))
        }
        return front
    }
    function swap(arr, old_index, new_index) {
        if (new_index < arr.length) {
            [arr[old_index], arr[new_index]] = [arr[new_index], arr[old_index]]
            let result = arr.map((item, index) => {
                return { ...item, number: index + 1 }
            })
            return result
        } else {
            return arr
        }
    }
    useEffect(() => {
        if (state) {
            if (state.pics) {
                setPic(state.pics)
                form.setFieldsValue({
                    pics: state.pics
                })
            }
            const start = moment(state.start * 1000)
            const end = moment(state.end * 1000)
            const { title, topics } = state;
            const arr = topics.map(item => {
                return {type:item.topic_type,number:item.number}
            })
            setTopic_number(arr)
            form.setFieldsValue({
                title,
                start,
                end,
            })
        }
    }, [state])
    const getButton = (length, move, name) => {
        if (state) {
            if (length == 1 && length < state.topics.length) {
                return <Button type="primary" onClick={() => {
                    move(name, name + 1)
                    setTopic_number(swap(topic_number, name, name + 1))
                    state.topics = swap(state.topics, name, name + 1)
                }}
                    style={{ marginLeft: "20px" }}
                >
                    下移
                </Button>
            } else if (length == 1) {
                return null
            }
            else if (length == state.topics.length) {
                return <Button type="primary" onClick={() => {
                    move(name, name - 1)
                    setTopic_number(swap(topic_number, name, name - 1))
                    state.topics = swap(state.topics, name, name - 1)
                }}
                    style={{ marginLeft: "20px" }}
                >
                    上移
                </Button>
            } else {
                return <>
                    <Button type="primary" onClick={() => {
                        move(name, name - 1)
                        setTopic_number(swap(topic_number, name, name - 1))
                        state.topics = swap(state.topics, name, name - 1)
                    }}
                        style={{ marginLeft: "20px" }}
                    >
                        上移
                    </Button>
                    <Button type="primary" onClick={() => {
                        move(name, name + 1)
                        setTopic_number(swap(topic_number, name, name + 1))
                        state.topics = swap(state.topics, name, name + 1)
                    }}
                        style={{ marginLeft: "20px" }}
                    >
                        下移
                    </Button>
                </>
            }
        } else {
            if (length == 1 && length < topic_number.length) {
                return <Button type="primary" onClick={() => {
                    move(name, name + 1)
                    setTopic_number(swap(topic_number, name, name + 1))
                }}
                    style={{ marginLeft: "20px" }}
                >
                    下移
                </Button>
            } else if (length == 1) {
                return null
            }
            else if (length == topic_number.length) {
                return <Button type="primary" onClick={() => {
                    move(name, name - 1)
                    setTopic_number(swap(topic_number, name, name - 1))
                }}
                    style={{ marginLeft: "20px" }}
                >
                    上移
                </Button>
            } else {
                return <>
                    <Button type="primary" onClick={() => {
                        move(name, name - 1)
                        setTopic_number(swap(topic_number, name, name - 1))
                    }}
                        style={{ marginLeft: "20px" }}
                    >
                        上移
                    </Button>
                    <Button type="primary" onClick={() => {
                        move(name, name + 1)
                        setTopic_number(swap(topic_number, name, name + 1))
                    }}
                        style={{ marginLeft: "20px" }}
                    >
                        下移
                    </Button>
                </>
            }
        }

    }

    return <>
        <Card
            title={state ? "修改投票" : "添加投票"}
            extra={<Button type="primary" onClick={history.goBack}>返回</Button>}
        >
            <Form
                form={form}
                labelCol={{ span: 8 }}
                wrapperCol={{ span: 8 }}
            >
                <Form.Item label="投票标题" name="title" rules={[{ required: true, message: "请输入标题" }]}>
                    <Input placeholder="请输入标题" />
                </Form.Item>
                <Form.Item label="投票图片" name="pics" >
                    <Uploadpic getSrc={garden_pic} src={pic} maxCount={8} />
                </Form.Item>
                {state ?
                    <Form.List name="topics"
                        initialValue={state.topics}
                    >
                        {(fields, { add, remove, move }) => (
                            <>
                                {
                                    fields.map(({ key, name, ...restField }) => {
                                        return <div className='infoItem' key={key}>
                                            <Form.Item label={name + 1} name={[name, 'topic_name']}
                                                rules={[{ required: true, message: "请输入问题" }]}
                                            >
                                                <Input placeholder={'请输入问题'} />
                                            </Form.Item>
                                            {(state.topics[name].topic_type == 1 ? <Form.Item wrapperCol={{ offset: 8 }} >
                                                <span>填写者回答区</span>
                                            </Form.Item> : null)
                                            }
                                            {[2, 3].includes(state.topics[name].topic_type) ? <>
                                                <Form.List name={[name, 'choice_items']}>
                                                    {(choiceList, { add: addchoice, remove: removechoice }) => (
                                                        <>
                                                            {choiceList.map((item, index) => {
                                                                return <div key={item.key} className="choiceList">
                                                                    <Form.Item label="选项" name={[item.name, "text"]}
                                                                        rules={[{ required: true, message: "请输入选项" }]}
                                                                    >
                                                                        <Input />
                                                                    </Form.Item>
                                                                    <Form.Item>
                                                                        <MinusCircleOutlined onClick={() => {
                                                                            removechoice(item.name)
                                                                        }} />
                                                                    </Form.Item>
                                                                </div>
                                                            })}
                                                            <div className="addChoice">
                                                                <span
                                                                    onClick={() => {
                                                                        addchoice()
                                                                    }}

                                                                >+添加选项</span>
                                                                <Select options={[
                                                                    { label: "单选", value: 2 },
                                                                    { label: "多选", value: 3 }
                                                                ]}
                                                                    defaultValue={state.topics[name].topic_type}
                                                                    className="spanChoice"
                                                                    onChange={(value) => {
                                                                        state.topics[name].topic_type = value
                                                                    }}
                                                                ></Select>
                                                            </div>
                                                        </>
                                                    )}
                                                </Form.List>
                                            </> : null}
                                            {(state.topics[name].topic_type == 4 ? <Form.Item label="评分" name={[name, "rate"]}>
                                                <Rate disabled defaultValue={0} />
                                            </Form.Item>
                                                : null)
                                            }
                                            <Form.Item
                                                label={<label style={{ color: "#03BB7A" }}>必填</label>}
                                                name={[name, 'must']}
                                                className="mustSwitch"
                                                labelCol={{ span: 2, offset: 8 }}
                                                colon={false}
                                                valuePropName="checked"
                                                extra={<>
                                                    {getButton(name + 1, move, name)}
                                                    <Button danger type="default" onClick={() => {
                                                        state.topics.splice(name,1)
                                                        remove(name)
                                                        setTopic_number(deleteAndReset(topic_number, name, 1))
                                                    }}
                                                        style={{ marginLeft: "20px" }}
                                                    >
                                                        删除
                                                    </Button>
                                                </>}
                                            >
                                                <Switch />
                                            </Form.Item>
                                        </div>
                                    })}
                                <div className="endTopics">
                                    {'添加题目'}
                                    <Button
                                        type='primary'
                                        style={{ marginLeft: '20px' }}
                                        ghost
                                        // disabled={!canEdit}
                                        shape='circle'
                                        onClick={() => {
                                            add({
                                                must: false,
                                                topic_type: 1
                                            })
                                            console.log(state.topics);
                                            
                                            state.topics.push({ topic_type: 1 })
                                            setTopic_number(pre => ([...pre, { number: topic_number.length - 0 + 1, type: 1 }]))
                                        }}
                                    >
                                        填空题
                                    </Button>
                                    <Button
                                        type='primary'
                                        style={{ marginLeft: '20px' }}
                                        ghost
                                        // disabled={!canEdit}
                                        shape='circle'
                                        onClick={() => {
                                            add({
                                                must: false,
                                                topic_type: 2
                                            })
                                            state.topics.push({ topic_type: 2 })
                                            setTopic_number(pre => ([...pre, { number: topic_number.length - 0 + 1, type: 2 }]))
                                        }}
                                    >
                                        选择题
                                    </Button>
                                    <Button
                                        type='primary'
                                        style={{ marginLeft: '20px' }}
                                        ghost
                                        // disabled={!canEdit}
                                        shape='circle'
                                        onClick={() => {
                                            add({
                                                must: false,
                                                topic_type: 4
                                            })
                                            state.topics.push({ topic_type: 4 })
                                            setTopic_number(pre => ([...pre, { number: topic_number.length - 0 + 1, type: 4 }]))
                                        }}
                                    >
                                        评分题
                                    </Button>
                                </div>
                            </>
                        )}
                    </Form.List>
                    : <Form.List name='topics'
                    >
                        {(fields, { add, remove, move }) => (
                            <>
                                {fields.map(({ key, name, ...restField }) => {
                                    return <div className='infoItem' key={key}>
                                        <Form.Item label={name + 1} name={[name, 'topic_name']}
                                            rules={[{ required: true, message: "请输入问题" }]}
                                        >
                                            <Input placeholder={'请输入问题'} />
                                        </Form.Item>
                                        {topic_number[name].type == 1 ? <Form.Item wrapperCol={{ offset: 8 }} >
                                            <span>填写者回答区</span>
                                        </Form.Item> : null}
                                        {[2, 3].includes(topic_number[name].type) ? <>
                                            <Form.List name={[name, 'choice_items']}>
                                                {(choiceList, { add: addchoice, remove: removechoice }) => (
                                                    <>
                                                        {choiceList.map((item, index) => {
                                                            return <div key={item.key} className="choiceList">
                                                                <Form.Item label="选项" name={[item.name, "text"]}
                                                                    rules={[{ required: true, message: "请输入选项" }]}
                                                                >
                                                                    <Input />
                                                                </Form.Item>
                                                                <Form.Item label="答案"
                                                                    name={[item.name, "flag"]}
                                                                    hidden
                                                                >
                                                                    <Input />
                                                                </Form.Item>
                                                                <Form.Item>
                                                                    <MinusCircleOutlined onClick={() => {
                                                                        removechoice(item.name)
                                                                    }} />
                                                                </Form.Item>
                                                            </div>
                                                        })}
                                                        <div className="addChoice">
                                                            <span
                                                                onClick={() => {
                                                                    addchoice()
                                                                }}

                                                            >+添加选项</span>
                                                            <Select options={[
                                                                { label: "单选", value: 2 },
                                                                { label: "多选", value: 3 }
                                                            ]}
                                                                defaultValue={topic_number[name].type}
                                                                className="spanChoice"
                                                                onChange={(value) => {
                                                                    let result = topic_number.map((item, index) => {
                                                                        if (index == name) {
                                                                            return { ...item, type: value }
                                                                        } else {
                                                                            return item
                                                                        }
                                                                    })
                                                                    setTopic_number(result)

                                                                }}
                                                            ></Select>
                                                        </div>
                                                    </>
                                                )}
                                            </Form.List>
                                        </> : null}
                                        {topic_number[name].type == 4 ?
                                            <Form.Item label="评分" name={[name, "rate"]}>
                                                <Rate disabled />
                                            </Form.Item>
                                            : null}
                                        <Form.Item
                                            label={<label style={{ color: "#03BB7A" }}>必填</label>}
                                            name={[name, 'must']}
                                            className="mustSwitch"
                                            labelCol={{ span: 2, offset: 8 }}
                                            colon={false}
                                            valuePropName="checked"
                                            extra={<>
                                                {getButton(name + 1, move, name)}
                                                <Button danger type="default" onClick={() => {
                                                    remove(name)
                                                    setTopic_number(deleteAndReset(topic_number, name, 1))
                                                }}
                                                    style={{ marginLeft: "20px" }}
                                                >
                                                    删除
                                                </Button>
                                            </>}
                                        >
                                            <Switch />
                                        </Form.Item>
                                        <Divider />
                                    </div>
                                })}
                                <div className="endTopics">
                                    {'添加题目'}
                                    <Button
                                        type='primary'
                                        style={{ marginLeft: '20px' }}
                                        ghost
                                        // disabled={!canEdit}
                                        shape='circle'
                                        onClick={() => {
                                            add({
                                                must: false,
                                                topic_type: 1
                                            })
                                            setTopic_number(pre => ([...pre, { number: topic_number.length - 0 + 1, type: 1 }]))
                                        }}
                                    >
                                        填空题
                                    </Button>
                                    <Button
                                        type='primary'
                                        style={{ marginLeft: '20px' }}
                                        ghost
                                        // disabled={!canEdit}
                                        shape='circle'
                                        onClick={() => {

                                            setTopic_number(pre => ([...pre, { number: topic_number.length - 0 + 1, type: 2 }]))
                                            add({
                                                must: false,
                                                topic_type: 2
                                            })
                                        }}
                                    >
                                        选择题
                                    </Button>
                                    <Button
                                        type='primary'
                                        style={{ marginLeft: '20px' }}
                                        ghost
                                        // disabled={!canEdit}
                                        shape='circle'
                                        onClick={() => {
                                            setTopic_number(pre => ([...pre, { number: topic_number.length - 0 + 1, type: 4 }]))
                                            add({
                                                must: false,
                                                topic_type: 4
                                            })
                                        }}
                                    >
                                        评分题
                                    </Button>
                                </div>
                            </>
                        )}
                    </Form.List>
                }
                <Form.Item label="投票开始时间" name="start" rules={[{ required: true, message: "请选择报名开始时间" }]}>
                    <DatePicker disabledDate={disabledDateStart} />
                </Form.Item>
                <Form.Item label="投票结束时间" name="end" rules={[{ required: true, message: "请选择报名结束时间" }]}>
                    <DatePicker disabledDate={disabledDateEnd} />
                </Form.Item>
            </Form>
            <div className="endTopics">
                <Button type="primary" onClick={addVote}>保存</Button>
            </div>
        </Card>
    </>
}

export default AddVote