import { Button, Card, Form, Image } from "antd";
import React from "react";
import { useHistory } from "react-router";
import { getLocalTime } from "../../../utils/utils";
import { TOPIC_TYPE } from "../../../CONSTANT";

const DetailVote = () => {
    const history = useHistory();
    const location = history.location
    const { state }: any = location
    const gridStyle: React.CSSProperties = {
        width: '50%',
        textAlign: 'center',
        marginBottom: "20px"
    };
    
    const topicsInfo = (item) => {
        return <div key={item.name}>
            < Form.Item label="投票编号">
                {item.number}
            </Form.Item>
            <Form.Item label="投票题目">
                {item.topic_name}
            </Form.Item>
            <Form.Item label="是否必选">
                {item.must ? "是" : "否"}
            </Form.Item>
            <Form.Item label="题目类型">
                {TOPIC_TYPE[item.topic_type]}
            </Form.Item>
        </div >

    }

    return <>
        <Card
            title={`${state.title}详情`}
            extra={<Button type="primary" onClick={history.goBack}>返回</Button>}
        >
            <Form
                labelCol={{ span: 4 }}
                labelAlign="left"
            >
                <Form.Item label="投票标题">
                    {state.title}
                </Form.Item>
                {state.pics ? <Form.Item label="图片">
                    {state.pics.map(item => {
                        return <Image src={item} key={item} style={{ height: '200px', width: '200px' }} />
                    })}
                </Form.Item> : null}
                {
                    state.topics.map(item => {
                        if (item.topic_type == 1) {
                            return <Card.Grid style={gridStyle} key={item.number}>
                                {topicsInfo(item)}
                            </Card.Grid>
                        }
                        else if ([2, 3].includes(item.topic_type)) {
                            return <Card.Grid style={gridStyle} key={item.number}>
                                {topicsInfo(item)}
                                {item.choice_items.map(key => {
                                    return <Form.Item label={key.flag} key={key.text} >
                                        {key.text}
                                    </Form.Item>
                                })}
                            </Card.Grid>
                        } else if (item.topic_type == 4) {
                            return <Card.Grid style={gridStyle} key={item.number}>
                                {topicsInfo(item)}
                                <Form.Item label="评分">
                                    {item.star}
                                </Form.Item>
                            </Card.Grid>
                        }
                    })
                }
                <Form.Item label="投票创建时间">
                    {getLocalTime(state.created_at)}
                </Form.Item>
                <Form.Item label="投票开始时间">
                    {getLocalTime(state.start)}
                </Form.Item>
                <Form.Item label="投票结束时间">
                    {getLocalTime(state.end)}
                </Form.Item>
            </Form>
        </Card>
    </>
}
export default DetailVote