import React from "react";
import { useHistory } from "react-router";
import ProTable from "@ant-design/pro-table";
import type { ActionType } from '@ant-design/pro-table'
import { Voteresult } from "../../../services/service/vote";
import { Button, Rate } from "antd";

const ResultDetail = () => {
    const history = useHistory();
    const location: any = history.location;
    const { number, id } = location.state;
    const actionRef = React.useRef<ActionType>();
    const columns: any = [
        {
            title: "用户名",
            dataIndex: "user_name"
        },
        {
            title: "投票答案",
            width: "50%",
            render: (_, row) => <>
                {row.answer.topic_type == 1 ? <>
                    {row.answer.completion_answers[0]}
                </> : ''}
                {[2, 3].includes(row.answer.topic_type) ? <>
                    {row.answer.choice_answers.map(item => <span style={{ marginRight: "20px" }} key={item}>{item}</span>)}
                </> : ''}
                {row.answer.topic_type == 4 ? <>
                    <Rate defaultValue={row.answer.star_answers} disabled />
                </> : ""}
            </>
        }
    ]

    return <>
        <ProTable
            actionRef={actionRef}
            rowKey="topic_name"
            search={false}
            request={Voteresult}
            params={{ number, id }}
            toolBarRender={() => [
                <Button type="primary" onClick={history.goBack}>返回</Button>
            ]}
            columns={columns}
        />
    </>
}

export default ResultDetail