import { Map, Marker } from 'react-amap';
import React, { useEffect, useState } from 'react';
import { Button } from 'antd';
import { connect } from 'react-redux';

const ZoomCtrl: any = (props) => {
    const { latitude, longitude } = props.markerPosition
    const map = props.__map__;
    const ele = props.__ele__;
    if (!map) {
        console.log('组件必须作为 Map 的子组件使用');
        return;
    }
    const style: any = {
        position: 'absolute',
        left: '10px',
        bottom: '10px',
        background: '#fff',
        padding: '10px'
    }
    const setZoomAndCenter = (level, center) => map.setZoomAndCenter(level, center)
    return (<div style={style}>
        <Button onClick={() => {
            setZoomAndCenter(15, [longitude, latitude])
        }}>点击回到所选区域</Button>
    </div>);
};

const MapElement = (props) => {
    useEffect(() => {
        const { lnt, lat } = props.garden_info
        setMapCenter({ longitude: lnt, latitude: lat })
        setMarkerPositiom({ longitude: lnt, latitude: lat })
    }, [props.garden_info])
    const [mapCenter, setMapCenter]: any = useState({})
    const [markerPosition, setMarkerPositiom]: any = useState({})
    //const mapKey = '0b397982744b3d2fe42799eba87f44c2'
    const events = {
        created: (instance) => {
           
        },
        click: (e) => {
            const lnt = e.lnglat.lng
            const lat = e.lnglat.lat
            setMarkerPositiom({ longitude: lnt, latitude: lat })
            props.location({ lnt, lat })
        }
    }
    //eslint-disable-next-line 
    
    return <div>
        <div style={{ width: 300, height: 300 }}>
            <Map
                events={events}
                center={mapCenter}
                plugins={['ToolBar', 'Scale']}
                zoom={15}
            >
                <Marker position={markerPosition} />
                <ZoomCtrl markerPosition={markerPosition} />
            </Map>
            {/* {
                props.lnglat ? <Map
                    events={events}
                    center={mapCenter}
                    plugins={['ToolBar']}
                    zoom={15}
                >
                    <Marker position={markerPosition} />
                </Map> : <><Map
                        events={events}
                        plugins={['ToolBar']}
                        zoom={15}
                    >
                        <Marker position={markerPosition} />
                        <ZoomCtrl adcode={props.adcode}/>
                    </Map></>
            } */}
        </div>
    </div>
}
const mapStateToProps = (state) => {
    return {
        garden_info: state.getGardenList.list,
    }
}

export default connect(mapStateToProps)(MapElement)