import React, { useEffect, useState } from "react";
import { Card, Button, Form, Input, Checkbox, Col, Row, message } from "antd";
import { LeftOutlined } from '@ant-design/icons'
import { PermissionAll, PermissionOption, PermissionInfo } from "../../services/permission";
import history from "../../utils/hisitory";
import Index from "./permission/permission";
import './roleList.scss'

const AddRole = (props) => {
    useEffect(() => {
        if (props.state) {
            form.setFieldsValue(props.state)
        }
    }, [])
    const [form] = Form.useForm()
    const addRole = () => {
        form.validateFields().then(async (value) => {
            await PermissionOption({ method: 'post', ...value })
            message.success('添加成功')
            history.goBack()
        })
    }
    const editRole = () => {
        form.validateFields().then(async (value) => {
            await PermissionOption({ method: 'put', ...value, id: props.state.id })
            message.success('修改成功')
            history.goBack()
        })
    }
    const getCode = (val) => {
        form.setFieldsValue({ permission_codes: val })
    }
    return (<>
        <Card
            extra={<Button type='primary' icon={<LeftOutlined />}
                onClick={history.goBack}
            >返回</Button>}
        >
            <Form
                form={form}
                labelAlign='left'
                labelCol={{ span: 3 }}
                wrapperCol={{ span: 10 }}
            >
                <Form.Item label='权限组名称' name='group_name' rules={[{ required: true, message: "请输入权限组名称" }]}>
                    <Input placeholder='请输入权限组名称'></Input>
                </Form.Item>
                <Form.Item label='权限描述' name='group_desc' rules={[{ required: true, message: "请输入权限组描述" }]}>
                    <Input.TextArea placeholder="请输入权限描述"></Input.TextArea>
                </Form.Item>
                <Form.Item label='权限列表' name='permission_codes' rules={[{ required: true, message: "请选择至少一种权限" }]}>
                    <Index val={props.state ? props.state.id : null} getCode={getCode} />
                </Form.Item>
            </Form>
            {!props.state ? <div className="creatuserBtn">
                <Button type="primary" onClick={addRole}>创建权限组</Button>
            </div> : <div className="creatuserBtn">
                <Button type="primary" onClick={editRole}>修改权限组</Button>
            </div>}

        </Card>
    </>)
}

export default AddRole