import React, { useEffect, useState } from "react";
import { PermissionAll, PermissionInfo } from "../../services/permission";
import { Card, Checkbox, Col, Row, Button, Form } from 'antd';
import { LeftOutlined } from '@ant-design/icons'
import { useHistory } from "react-router";
import { getPermisssionList, changePermission } from "../../redux/action/permisssion/user";
import { connect, useStore } from 'react-redux'
import Index from "./permission/permission";
import './roleList.scss'

const RoleList = (props) => {
  const history = useHistory();
  const location = history.location
  const state: any = location.state

  return (<>
    <Card
      extra={<Button type='primary' icon={<LeftOutlined />}
        onClick={history.goBack}
      >返回</Button>}
    >
      <Index val={state.id} disable={true}  />
    </Card>
  </>)
}

const mapStateToProps = (state) => {
  return {
    group_info: state.userReducer.list,
    premission_codes: state.userReducer.data
  }
}

const mapDispatchToProps = (dispatch) => {
  return {
    getPermission: (userInput) => dispatch(getPermisssionList(userInput)),
    getPermisssion_codes: (data) => dispatch(changePermission(data))
  }
}
export default connect(mapStateToProps, mapDispatchToProps)(RoleList);