import { Button, message } from "antd";
import React from "react";
import { useHistory } from "react-router";
import type { ActionType } from "@ant-design/pro-table";
import ProTable from "@ant-design/pro-table";
import { User } from "../../services/user";
import { Link } from "react-router-dom";
import { PlusOutlined } from "@ant-design/icons";

const RoleUser = (props) => {
    const history = useHistory();
    const location = history.location
    const state: any = location.state
    const actionRef:any = React.useRef<ActionType>()
    const deleteUser = async (id) =>{
        await User({method:'delete',id})
        message.success('删除成功')
        actionRef.current.reload();
    }
    const columns: any = [
        {
            title: "成员",
            align: "center",
            dataIndex: "user_name"
        }, {
            title: "创建时间",
            align: "center",
            dataIndex: "created_at"
        }, {
            title: "操作",
            dataIndex: "option",
            align: "center",
            render:(_,row)=><Button type="link" onClick={()=>deleteUser(row.id)}>删除</Button>
        }
    ]
    
    return <>
    <ProTable 
    actionRef={actionRef}
    rowKey="id"
    search={false}
    columns={columns}
    request={User}
    params={{group_id:state.id}}
    toolBarRender={()=>[
        <Link to={{pathname:"/admin/account/list/adduser",state:state.id}}>
        <Button
         icon={<PlusOutlined />}
         type='primary'
        >添加用户</Button>
        </Link>,
        <Button
        type="primary"
        onClick={()=>{
            history.goBack()
        }}
        >返回</Button>
    ]}
    />
    </>
}

export default RoleUser