import React from 'react'
import type { ActionType } from '@ant-design/pro-table'
import ProTable from '@ant-design/pro-table'
import { Button, Modal, Form, message } from 'antd'
import { Link, withRouter } from 'react-router-dom'
import { Car } from '../../services/parking'
import { GetPermissionGroups, PermissionOption } from '../../services/permission'
import { useHousehold } from "../Owner/hooks"
import './index.scss'

const Roles: React.FC = (props: any) => {
  const columns: any = [
    {
      title: '名称',
      dataIndex: 'group_name',
      search: true,
    },
    {
      title: '描述',
      dataIndex: 'group_desc',
      search: false,
    },
    {
      title: '人数',
      dataIndex: 'user_count',
      search: false,
    },
    {
      title: '操作',
      dataIndex: 'option',
      search: false,
      width: 300,
      align: 'center',
      render: (_, row, index, action) => <>
        <Link to={{ pathname: "/admin/account/roles/rolelist", state: row }}>
          <Button type='link'>权限</Button>
        </Link>
        <Link to={{pathname:"/admin/account/roles/roleuser",state:row}}>
        <Button type='link'>用户</Button>
        </Link>
       <Link to={{ pathname: "/admin/account/roles/editrole" ,state:row}}>
       <Button type='link' disabled={row.super?true:false}>编辑</Button>
       </Link>
        <Button type='link'  disabled={row.super?true:false} onClick={() => {
          Modal.confirm({
            title: '删除记录',
            content: '你确定删除这条记录吗？',
            onOk: async () => {
              await PermissionOption({ method: 'delete', id: row.id })
              message.success('操作成功！')
              actionRef.current.reload()
            }
          })
        }}>删除</Button>
      </>
    }
  ]

  const actionRef: any = React.useRef<ActionType>()

  return (
    <React.Fragment>
      <ProTable
        actionRef={actionRef}
        rowKey="id"
        search={false}
        request={GetPermissionGroups}
        toolBarRender={() => [
          <Link to={{ pathname: "/admin/account/roles/addrole" }}>
            <Button type='primary'>添加权限组</Button>
          </Link>
        ]}
        columns={columns}
      />
    </React.Fragment>
  )
}

export default withRouter(Roles)