import { Button, Card, Form } from "antd";
import React, { useEffect, useState } from "react";
import { useHistory } from "react-router";
import { getUserList } from "../../redux/action/building";
import { connect } from "react-redux";
import { id_type, user_type } from "../../CONSTANT";
import "./index.scss"

const HouseholdUserlist = (props) => {
    const history = useHistory();
    const location = history.location
    const house_id: any = location.state
    useEffect(() => {
        props.getUserList({ house_id })
    }, [])
    const ownerForm = [
        { label: "姓名", name: "name" },
        { label: "证件类型", name: "id_type" },
        { label: "证件号码", name: "id_number" },
        { label: "联系电话", name: "phone" },
        { label: "住户身份", name: "user_type" }
    ]

    return <>
        <Card
            title="业主信息"
            extra={<Button type="primary" onClick={history.goBack}>返回</Button>}
        >
            {
                props.user_info.map(item => {
                    return <Form
                        layout='inline'
                        className="user_infoList"
                        key={item.id}
                    >
                        {ownerForm.map(key => {
                            if (key.name == "id_type") {
                                return <Form.Item label={key.label} key={key.label}>
                                    <span>{id_type[item.id_type]}</span>
                                </Form.Item>
                            } else if (key.name == 'user_type') {
                                return <Form.Item label={key.label} key={key.label}>
                                    <span>{user_type[item.id_type]}</span>
                                </Form.Item>
                            } else {
                                return <Form.Item label={key.label} key={key.label}>
                                    <span>{item[key.name]}</span>
                                </Form.Item>
                            }
                        })}
                    </Form>

                })
            }
        </Card>
    </>
}
const mapStateToProps = (state) => {
    return {
        user_info: state.getUserInfo.list,
    }
}

const mapDispatchToProps = (dispatch) => {
    return {
        getUserList: (userInput) => dispatch(getUserList(userInput)),
    }
}

export default connect(mapStateToProps, mapDispatchToProps)(HouseholdUserlist)